'.----------+----------+--------- [Message] --------+---------------------:
'|                       Request System v1.00 by TuS                      |
':----------+----------+----------+-----------------+---------------------:

'**************************************************************************
'* Copyright (C) 2011                                                     *
'* TuS, tustus[at]hotmail[dot]com                                         *
'*                                                                        *
'* This program is free software; you can redistribute it and/or modify   *
'* it under the terms of the GNU General Public License as published by   *
'* the Free Software Foundation; either version 2 of the License, or      *
'* (at your option) any later version.                                    *
'*                                                                        *
'* This program is distributed in the hope that it will be useful, but    *
'* WITHOUT ANY WARRANTY; without even the implied warranty of             *
'* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                   *
'* See the GNU General Public License for more details.                   *
'*                                                                        *
'* You should have received a copy of the GNU General Public License      *
'* along with this program; if not, write to the                          *
'* Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,    *
'* MA 02111-1307 USA                                                      *
'**************************************************************************
'**************************************************************************
'* VBS Script logging Framework :                                         *
'* Copyright (C) 2006                                                     *
'* Christer Finsen, mind[underscore]trip[at]users[dot]sourceforge[dot]net *
'* Nils-Erik Aurker, nils-erik[at]users[dot]sourceforge[dot]net          *
'**************************************************************************

Option Explicit 

'Import Configuration
Import ("Request.Config")

'Make sure constants in message.config are correctlly defined
If TypeName(RAIDENFTPD_PATH) <> "String" _
	Or TypeName(REQUEST_FOLDER) <> "String" _
	Or TypeName(REQUEST_MOVE_FILLED) <> "Boolean" _
	Or TypeName(REQUEST_FILLED_FOLDER) <> "String" _
	Or TypeName(REQUEST_ADD_OPS_ONLY) <> "Boolean" _
	Or TypeName(REQUEST_DELETE_OPS_ONLY) <> "Boolean" _
	Or TypeName(REQUEST_FILL_OPS_ONLY) <> "Boolean" _
	Or TypeName(REQUEST_HEAD_REQ) <> "String" _
	Or TypeName(REQUEST_HEAD_FILLED) <> "String" _
	Or TypeName(REQUEST_MAX_LIMIT) <> "Integer" _
	Or TypeName(REQUEST_MAX_LIMIT) <> "Integer" _
	Or TypeName(REQUEST_CHMODE) <> "Boolean" _
	Or TypeName(REQUEST_MODE_REQUEST) <> "Integer" _
	Or TypeName(REQUEST_MODE_FILLED) <> "Integer" _
	Or TypeName(ADDON_ENABLE_NOTIFICATION) <> "Boolean" _
	Or TypeName(ADDON_MESSAGE_PATH) <> "String" _
	Or TypeName(REQUEST_MSGFILE_ENABLE) <> "Boolean" _
	Or TypeName(REQUEST_DIRMSGFILE_ENABLE) <> "Boolean" _
	Or TypeName(REQUEST_DIRMSGFILE_NAME) <> "String" _
	Or TypeName(REQUEST_DIRMSGFILE_NFO) <> "String" _
	Or TypeName(REQUEST_MSGFILE_NFO) <> "String" _
	Or TypeName(REQUEST_LIST_NFO) <> "String" _
	Or TypeName(SCENEVIEW) <> "Boolean" _
	Or TypeName(WIDTH) <> "Integer" _
	Or TypeName(SCENEHEADER) <> "String" _
	Or TypeName(SCENESEPARATOR) <> "String" _
	Or TypeName(SCENETAIL) <> "String" _
	Or TypeName(NORMALHEADER) <> "String" _
	Or TypeName(EVENTLOG) <> "Integer" _
	Or TypeName(FILELOG) <> "Integer" _
	Or TypeName(NUMBEROFLOGS) <> "Integer" Then
	WScript.echo "One or more required constants is not defined. Please see " _
	& "Message_Readme.txt for installation"
	WScript.quit
End If

'*********************************************************************************
'*********************************************************************************
'       DO NOT CHANGE THESE CONSTANTS UNLESS YOU KNOW WHAT YOU ARE DOING
'*********************************************************************************
Const APPNAME       = "TuS Request System"
Const APPVERMAJOR   = "1"
Const APPVERMINOR   = "00"
Const AUTHOR        = "TuS"
Const COPYYEAR      = "2011"
Const FORREADING    = 1
Const FORWRITING    = 2
Const FORAPPENDING  = 8
Const SUCCESS       = 0
Const ERRORL        = 1
Const WARNING       = 2
Const INFORMATION   = 4
Const ABORT         = "Script aborted with error(s). To determine cause, see logged information"
Const SITECMD       = "request"
'*********************************************************************************
'Script Root folder
Dim SCRIPTPATH : SCRIPTPATH = Left(WScript.ScriptFullName, InStrRev(WScript.ScriptFullName,"\")-1)
Dim SCRIPTNAME : SCRIPTNAME = Left(WScript.ScriptName, InStrRev(WScript.ScriptName,".")-1)
'012345678901234567890123456789012345678901234567890123456789012345678901234567891

'#################################################################################
'	Main Entry Point
'#################################################################################
Dim iCnt
Dim cmdGCID,cmdLEVEL,cmdSERVER,cmdUSER,cmdUSERGRP,cmdSITECMD,cmdCMD,cmdOPTION1,cmdOPTION2,cmdOPTION3
Dim oArgs : Set oArgs = WScript.Arguments

Dim currentSub : currentSub = "Main Code"
Dim tStartTime,tEndTime

'Debug Class level Events
Const DEBUG_CLASS_EVENTS = False
Const FIRE_CLASS_EVENTS  = False

tStartTime = Timer()
'#-------------------------------------------------------------------------------#
'Load the framwork
'#-------------------------------------------------------------------------------#
'Init the Logger
Dim UserLog : Set UserLog = New UserLogClass

'Init the Helper
Dim Helper : Set Helper = New HelperClass

'start the logger
UserLog.Start
'#-------------------------------------------------------------------------------#
UserLog.LogEvent SUCCESS, "*** " & APPNAME & " " & APPVERMAJOR & "." & APPVERMINOR & " by " & AUTHOR & " ***"
UserLog.LogEvent SUCCESS, APPNAME & " Ver." & APPVERMAJOR & "." & APPVERMINOR & " Copyright(C) " & COPYYEAR
UserLog.LogEvent SUCCESS, APPNAME & " Ver." & APPVERMAJOR & "." & APPVERMINOR & " comes with ABSOLUTELY NO WARRANTY;"
UserLog.LogEvent SUCCESS, "This is free software, and you are welcome to redistribute it under certain" 
UserLog.LogEvent SUCCESS, "conditions; Read License.txt for details." 
UserLog.LogEvent SUCCESS, "VBS Script logging Framework: Copyright(C) 2006 Christer Finsen,and Nils-Erik Aurker" 
UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"

UserLog.LogEvent INFORMATION, "[" & currentSub & "] Collecting Script Arguments"
UserLog.LogEvent INFORMATION, "[" & currentSub & "] Number of Arguments : " & oArgs.Count

'Init the command Processor
Dim CmdProcessor : Set CmdProcessor = New CmdProcessorClass

'Init the Classes
Dim RaidenOutFile : Set RaidenOutFile = New RaidenOutFileClass
Dim RaidenReqStoreFile : Set RaidenReqStoreFile	= New RaidenReqStoreFileClass

'Simple verification that the FTPD process is initiating the command in a way we expect
If oArgs.Count < 5 Then
	UserLog.LogEvent ERRORL, "[" & currentSub & "] FTPD or this installation has been tampered with. This command needs at least FIVE arguments to run"
	WScript.Quit
End If

'Assign Main Parameters
For iCnt = 0 To oArgs.Count -1 
	UserLog.LogEvent INFORMATION, "[" & currentSub & "] Argument#" & iCnt+1 & ", Value=" & oArgs(iCnt)
	
	Select Case iCnt
		Case 0
		cmdGCID = oArgs(iCnt)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] GCID=" & cmdGCID
		Case 1
		cmdLEVEL = oArgs(iCnt)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] LEVEL=" & cmdLEVEL
		Case 2
		cmdSERVER = oArgs(iCnt)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] SERVER=" & cmdSERVER
		Case 3
		cmdUSER = oArgs(iCnt)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] USER=" & cmdUSER
		Case 4
		cmdUSERGRP = oArgs(iCnt)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] USERGRP=" & cmdUSERGRP
		Case 5
		cmdSITECMD = oArgs(iCnt)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] SITECOMMAND=" & cmdSITECMD
		Case 6
		cmdCMD = oArgs(iCnt)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] COMMAND=" & cmdCMD
	End Select
Next	

' Assign Class Properties (This is the working Context)
'#-------------------------------------------------------------------------------#
RaidenOutFile.GCID 			= cmdGCID
RaidenOutFile.Server		= cmdSERVER
RaidenOutFile.Path			= RAIDENFTPD_PATH
RaidenOutFile.SceneView 	= SCENEVIEW
RaidenOutFile.Width			= WIDTH

RaidenReqStoreFile.Server 	= cmdSERVER
RaidenReqStoreFile.User		= cmdUSER
RaidenReqStoreFile.Path		= SCRIPTPATH & "\Store"

'#-------------------------------------------------------------------------------#
'Dispatch the command
CmdProcessor.CommandDispatcher

UserLog.LogEvent SUCCESS, "[Main Code] " & APPNAME & " " & APPVERMAJOR & "." & APPVERMINOR & " Completed"
UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
'#################################################################################
'	Main Exit Point
'#################################################################################

'######################################################################################
' Class Wrapper for RaidenFTPD REQSYS Store File
'######################################################################################
Class RaidenReqStoreFileClass
	
	'Class vars
	Private c_sServer, c_sUser, c_bOutputResult, c_sFilePath, c_aItems,c_iCount,c_iNewCount
	
	'Local vars
	Private	oFso, oStoreFile
	Private iItemCnt,iNewItemCnt
	Private	sLine, sFile, sElement, sTime, sItem, aDataItems
	Private	bLoaded, bSaved, bFileExists, bIsNew 
	Private tTime

	'#---------------------------------------------------------------------------#
	Private Sub Class_Initialize
		c_bOutputResult		= False
		c_sFilePath 		= vbNullString
		c_sUser 			= vbNullString
		c_sServer 			= vbNullString
		c_iCount		    = 0
		c_iNewCount	        = 0
		bLoaded				= False
		bSaved				= False
		Set c_aItems 	    = New ArrayWrapper
		c_aItems.oType	    = "REQUESTS"
		c_aItems.Parent     = me
		Set oStoreFile	    = Nothing
		Set oFso			= CreateObject("Scripting.FileSystemObject")
		sFile			    = vbNullString
		
	End Sub
	
	Private Sub Class_Terminate
		Set oFso			= Nothing
		Set oStoreFile	    = Nothing
		Set c_aItems		= Nothing
	End Sub
	
	Public Sub Class_Event(sSource, sEventType, ByVal bResult, ByVal values)
		'********************************************************************************
		' Purpose : Fire an event received from the child objects
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenStoreFile:Class_Event"
		
		If IsArray(values) Then
			values = Join(values,"|")
		End If 
		
		If (TypeName(DEBUG_CLASS_EVENTS) <> "Nothing") Then
			If (DEBUG_CLASS_EVENTS = True) Then
				WScript.Echo "EVENT FIRED [" & currentSub & "] source: " & sSource & " ; EventType:" & sEventType & " ; Result:" & bResult & " ; values:" & values
			End If
		End If 
	End Sub
	'#---------------------------------------------------------------------------#
	
	Public Property Get Path()
	Path = c_sFilePath
	End Property
	
	Public Property Let Path(sScriptPath)
	If sScriptPath <> vbNullString Then
		c_sFilePath = sScriptPath
	End If 
	End Property
	
	Public Property Get Loaded()
	Loaded = bLoaded
	End Property
	
	Public Property Get Saved()
	Saved = bSaved
	End Property
	
	Public Property Get Server()
	Server = c_sServer
	End Property
	
	Public Property Let Server(sServer)
	If (VarType(sServer) = vbString) Then
		c_sServer = sServer
	End If 
	End Property
		Public Property Get User()
	User = c_sUser
	End Property
	
	Public Property Let User(sUser)
	If (VarType(sUser) = vbString) Then
		c_sUser = sUser
	End If 
	End Property
	
	Public Property Get Count()
	Count = c_iCount
	End Property
	
	Public Property Get NewCount()
	NewCount = c_iNewCount
	End Property
	
	Public Property Get Items()
	Set Items = c_aItems
	End Property
	'#---------------------------------------------------------------------------#
	
	Public Sub load()
		'********************************************************************************
		' Purpose : Create an FTPD Message store as an object oOut
		' Input   : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenStoreFile:load"
		
		'On Error Resume Next
		
		'Reset the MsgStoreFile
		Set oStoreFile 	= Nothing
		Items.clear
		sLine				= vbNullString
		iItemCnt 			= 0
		iNewItemCnt 		= 0
		
		Helper.CreateFolder(c_sFilePath)
		sFile = c_sFilePath & "\" & c_sServer & "-Requests.dat"
		bFileExists = Helper.FileExists(sFile, False)
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] file: " & sFile & " Exists: " & bFileExists	
		
		If (bFileExists = False) Then
			Set oStoreFile = oFso.CreateTextFile(sFile, True)
			If Err.number <> 0 Then
				UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to create store file: " & sFile & " The error was : " & Err.description & " (" & Err.number & ")"
				CmdProcessor.TerminateInSysErr
			Else
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] File: " & sFile & " was successfully created."
			End If
		End If
		
		Set oStoreFile = oFso.OpenTextFile(sFile, FORREADING)
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to open store file: " & sFile & " The error was : " & Err.description & " (" & Err.number & ")"
			CmdProcessor.TerminateInSysErr
		Else
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] store file: " & sFile & " was successfully opened for read."
		End If
		
		'Read Request file, parsing lines
		Do Until oStoreFile.AtEndOfStream
			aDataItems 	= Split(oStoreFile.ReadLine,Chr(127))
			If Helper.GetSize(aDataItems) = 7 Then
				c_aItems.AddItem aDataItems
				iItemCnt = iItemCnt + 1
				If (aDataItems(0) = "1") Then
					iNewItemCnt 	= iNewItemCnt + 1
				End If 
			End If
		Loop
		oStoreFile.close()
		
		c_iCount 	= iItemCnt
		c_iNewCount = iNewItemCnt
		
		'set the class status
		bLoaded = True
		bSaved 	= True
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] Store file: Found " & iItemCnt 
	End Sub
	
	Private Sub Save()
		'********************************************************************************
		' Purpose : save an FTPD Message store
		' Input   : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenStoreFile:Save"
		
		'Reset the MsgStoreFile
		Set oStoreFile 	= Nothing
		Set aDataItems	= Nothing
		sFile			= vbNullString
		iItemCnt 		= 0
		iNewItemCnt 	= 0
		
		Helper.CreateFolder(c_sFilePath)
		sFile = c_sFilePath & "\" & c_sServer & "-Requests.dat"
		
		Set oStoreFile = oFso.CreateTextFile(sFile, True)
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to create store file: " & sFile & " The error was : " & Err.description & " (" & Err.number & ")"
			CmdProcessor.TerminateInSysErr
		Else
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] File: " & sFile & " was successfully created."
		End If
		
		'Read Local Message array and write to file
		For Each aDataItems In Items.Data
			'check the New Message status
			If (aDataItems(0) = "1") Then
				iNewItemCnt = iNewItemCnt + 1
			End If	
			iItemCnt = iItemCnt + 1
			oStoreFile.WriteLine Join(aDataItems,Chr(127))
		Next
		oStoreFile.close()
		
		c_iCount 	= iItemCnt
		c_iNewCount = iNewItemCnt
		
		'set the class status
		bSaved = True
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Saved Store file with  " & iItemCnt & " Items"
	End Sub
	
	Public Function ReadItems(sServer)
		'********************************************************************************
		' Purpose : Read an FTPD store as an object oOut
		' Input   : String : sServer	: the Destination sServer
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenStoreFile:ReadItems"

		'load the user message file
		c_sServer = sServer
		If Loaded = False Then
			Load()
		End If
		ReadItems = Items.Data
	End Function
	
	Public Function DeleteAll()
		'********************************************************************************
		' Purpose : Reset the FTPD  store as an object oOut
		' Input   : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenStoreFile:DeleteAll"
		
		If (Items.clear) Then
			c_iCount 	= 0
			c_iNewCount = 0
			bSaved 		= False
		End If 
		save
	End Function
	
	Public Function AddItem(sServer, sUser, sGroup, sSource, sItem)
		'********************************************************************************
		' Purpose : Add a new Item
		' Input   :	String : sServer : the Source Server
		'           String : sUser	 : the Source User
		'           String : sGroup	 : the Source UserGroup
		'           String : sSource : the Source Raiden|irc
		'			String : sItem	 : the Item
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenStoreFile:AddItem"
		
		'init vars
		tTime 	= Empty
		sTime	= Empty
		
		'load the Store file
		Server = sServer
		load	
		
		tTime = Now()
		sTime = FormatDateTime(Now(),2) & " " & FormatDateTime(Now(),4)
		
		On Error Resume Next
		
		tTime = Now()
		sTime = FormatDateTime(Now(),2) & " " & FormatDateTime(Now(),4)
		sElement = Array("1",sTime,sServer,sUser,sGroup,sSource,sItem)
		
		If (Items.AddItem(sElement)) Then
			c_iCount 	= c_iCount + 1
			c_iNewCount = c_iNewCount + 1
			bSaved 		= False
		End If 
		
		Save
	End Function
	
	Public Function DeleteItem(sValue, iPos)
		'********************************************************************************
		' Purpose : Delete a message for a user
		' Input   :	String : sValue	: the Request sValue
		'           Integer: iPos   : The position to check in the item
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenStoreFile:DeleteItemPos"
		
		'init vars
		bIsNew 		= false
		sItem    	= vbnullString
		DeleteItem	= False
		
		sItem = Items.GetItemByValuePos(sValue,iPos)
		If (IsArray(sItem)) Then
			If (sItem(0) = "1") Then 
				bIsNew = True
			Else 
				bIsNew = False
			End If
			
			If (Items.DeleteItemByValuePos(sValue,iPos)) Then
				c_iCount 	= c_iCount - 1
				If bIsNew = True Then
					c_iNewCount 	= c_iNewCount - 1
				End If
				bSaved 				= False
			End If 
			
			Save
			DeleteItem = True
		End If 
	End Function
	
	Public Function GetItemValue(sItem, iPos)
		'********************************************************************************
		' Purpose : Retreive the item
		' Input   :	string : sItem	: the Item value
		'           Integer: iPos   : The position to check in the item
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenStoreFile:GetItemValue"
		Dim Item
		
		'Default the result 
		GetItemValue = vbnullstring
		
		For Each Item In (ReadItems(Server))
			If Item(iPos) = sItem then
				GetItemValue = Item
				Exit function
			End If
		Next
 
	End Function
	
	Public Sub ResetNewItems(sDestUser)
		'********************************************************************************
		' Purpose : Create an FTPD Message store as an object oOut
		' Input   : String : sDestUser : the Destination user
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenStoreFile:ResetNewItems"
		
		'Init the local vars
		Set aDataItems = Nothing
		iItemCnt 	= 0
		iNewItemCnt 	= 0
		
		On Error Resume Next
		
		c_sDestUser = sDestUser
		If Loaded = False Then
			Load()
		End If
		
		If NewMessageCount > 0 Then
			'Reset the status
			For Each aDataItems In Messages.Data
				'check the New Message status
				If (aDataItems(0) = "1") Then
					Messages.UpdateItem iItemCnt+1,Array("0",aDataItems(1),aDataItems(2),aDataItems(3))
					iNewItemCnt = iNewItemCnt + 1
					c_iNewCount 	= c_iNewCount - iNewItemCnt
					bSaved = False
				End If	
				iItemCnt = iItemCnt + 1
			Next
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] " & iNewItemCnt & " New Items were reset for user " & c_sDestUser
		Else 
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] 0 New Items to reset for user " & c_sDestUser
		End If 
		'Now save the data back to message store file
		If bSaved = False Then
			Save
		End If
	End Sub		
End Class

'######################################################################################
' Class Wrapper for RaidenFTPD Command Output File
'######################################################################################
Class RaidenOutFileClass
	
	'local vars
	Private sUserFile
	Private	oFile,oFso,oOutFile,oOut
	Private	sStr, sLine, sTmpStr  	
	Private ilength,iStrLength,ilenth1,ilenth2
	Private aMultiLineMsg
	
	'class vars
	Private c_sServer, c_sDestUser,c_sDestFile, c_iWidth, c_bSceneView, c_bOutputResult, c_sFilePath, c_sGCID, c_sCmdType
	
	'#---------------------------------------------------------------------------#
	Private Sub Class_Initialize
		c_bOutputResult	= True
		c_bSceneView	= True
		c_sFilePath 	= vbNullString
		c_sGCID 		= vbNullString
		c_sServer 		= vbNullString
		c_sDestUser		= vbNullString
		c_sCmdType		= "SiteCommand"
		c_iWidth		= 71
		Set oFile		= Nothing
		Set oOut		= Nothing
		Set oFso		= CreateObject("Scripting.FileSystemObject")
	End Sub
	
	Private Sub Class_Terminate
		Set oFso	= Nothing
		Set oFile	= Nothing
		Set oOut	= Nothing
	End Sub
	
	Public Property Get Path()
	Path = c_sFilePath
	End Property
	
	Public Property Let Path(sPath)
	If sPath <> vbNullString Then
		c_sFilePath = sPath
	End If 
	End Property
	
	Public Property Get Width()
	Width = c_iWidth
	End Property
	
	Public Property Let Width(iWidth)
	c_iWidth = iWidth
	End Property
	
	Public Property Get SceneView()
	SceneView = c_bSceneView
	End Property
	
	Public Property Let SceneView(bSceneView)
	c_bSceneView = bSceneView
	End Property
	
	Public Property Get Result()
	Result = c_bOutputResult
	End Property
	
	Public Property Get UserFile()
	UserFile = sUserFile
	End Property
	
	Public Property Let Result(bOutputResult)
	If TypeName(bOutputResult) = vbBoolean Then
		c_bOutputResult = bOutputResult
	End If 
	End Property
	
	Public Property Get GCID()
	GCID = c_sGCID
	End Property
	
	Public Property Let GCID(sGCID)
	If sGCID <> vbNullString Then
		c_sGCID = sGCID
	End If 
	End Property
	
	Public Property Get Server()
	Server = c_sServer
	End Property
	
	Public Property Let Server(sServer)
	If (VarType(sServer) = vbString) Then
		c_sServer = sServer
	End If 
	End Property
	
	Public Property Get DestUser()
	DestUser = c_sDestUser
	End Property
	
	Public Property Let DestUser(sDestUser)
	If (VarType(sDestUser) = vbString) Then
		c_sDestUser = sDestUser
	End If 
	End Property
	
	Public Property Get DestFile()
	DestFile = c_sDestFile
	End Property
	
	Public Property Let DestFile(sDestFile)
	If (VarType(sDestFile) = vbString) Then
		c_sDestFile = sDestFile
		Set oOut = Nothing
	End If 
	End Property
	
	Public Property Get CmdType()
	CmdType = c_sCmdType
	End Property
	
	Public Property Let CmdType(sCmdType)
	If sCmdType <> vbNullString Then
		c_sCmdType = sCmdType
		Set oOut = Nothing
	End If 
	End Property	
	'#---------------------------------------------------------------------------#
	
	Public Sub Initialize()
		'********************************************************************************
		' Purpose : Create an FTPD reply (Output file) as an object oOut
		' Input   : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:Initialize"
		
		On Error Resume Next
		Err.clear
		
		Select Case LCase(CmdType)
			Case "userlogin"
				sUserFile = c_sFilePath & "\OutPut" & "\ask-on" & c_sCmdType & "." & c_sGCID
			Case "sitecommand"
				sUserFile = c_sFilePath & "\OutPut" & "\ask-on" & c_sCmdType & "." & c_sGCID
			Case "notify"
				sUserFile = Path & "\Message" & "\site-Request-" & Server & ".msg"
			Case "dirfile"
				sUserFile = c_sDestFile
		End select
		
		'Set oOut = oFso.CreateTextFile(sUserFile, True)
		'Replaced code to manage hidden files
		If oFso.FileExists(sUserFile) Then		
			Set oOutFile = oFso.GetFile(sUserFile)
			Set oOut     = oOutFile.OpenAsTextStream(FORWRITING)
		Else
			Set oOut = oFso.CreateTextFile(sUserFile, True)
		End If 

		
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to create output: " & sUserFile & ". The error was : " & Err.description & " (" & Err.number & ")"
			CmdProcessor.Terminate
		Else
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] File: " & sUserFile & " was successfully created."
		End If
		
	End Sub	
	
	Sub WriteResultOnly()
		'********************************************************************************
		' Puropose : Write the common intro of every user reply
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:WriteResultOnly"
		
		If Helper.IsNothing(oOut) Then 
			Initialize
		End If 
		
		If (c_bOutputResult = True) Then 
			oOut.WriteLine "1"
		Else 
			oOut.WriteLine "0"
		End If
		
		Close
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Result : " & c_bOutputResult
	End Sub
	
	
	Sub WriteMsgHeader()
		'********************************************************************************
		' Puropose : Write the common intro of every user reply
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:WriteMsgHeader"
		
		If Helper.IsNothing(oOut) Then 
			Initialize
		End If 
		
		If (c_bOutputResult = True) Then 
			oOut.WriteLine "1"
		Else 
			oOut.WriteLine "0"
		End If
		
		If c_bSceneView Then
			sStr = SCENEHEADER
		Else
			sStr = NORMALHEADER
		End If
		If (sStr <> vbNullString) Then
			oOut.WriteLine sStr
		End If
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message Header."
	End Sub
	
	Sub WriteNFO(sStr, bOutputResult)
		'********************************************************************************
		' Puropose : Write the a template NFO to output
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:WriteNFOHeader"
		
		If Helper.IsNothing(oOut) Then 
			Initialize
		End If 
		
		If (bOutputResult = True) Then 
			oOut.WriteLine "1"
		End If
		
		If (sStr <> vbNullString) Then
			oOut.WriteLine sStr
		End If
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write NFO Template"
	End Sub
	
	Sub WriteMsgHeaderNoResult()
		'********************************************************************************
		' Puropose : Write the common intro of every user reply
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:WriteMsgHeaderNoResult"
		
		If Helper.IsNothing(oOut) Then 
			Initialize
		End If 
		
		If c_bSceneView Then
			sStr = SCENEHEADER
		Else
			sStr = NORMALHEADER
		End If
		If (sStr <> vbNullString) Then
			oOut.WriteLine sStr
		End If
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message Header No Result."
	End Sub
	
	Sub WriteMsgSeparator()
		'********************************************************************************
		' Purpose : Build up a Formated Seperator string
		' Input   : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:WriteMsgSeparator"
		
		If Helper.IsNothing(oOut) Then 
			Initialize
		End If 	
		
		If c_bSceneView Then
			sStr = SCENESEPARATOR
		Else
			sStr = NORMALSEPARATOR
		End If
		If (sStr <> vbNullString) Then
			oOut.WriteLine sStr
		End If
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message Seperator"
	End Sub
	
	Sub WriteMsgTail()
		'********************************************************************************
		' Puropose : Write the common last lines of every user reply
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:WriteMsgTail"
		
		If Helper.IsNothing(oOut) Then 
			Initialize
		End If 
		
		If c_bSceneView Then
			sStr = SCENETAIL
		Else
			sStr = NORMALTAIL
		End If
		If (sStr <> vbNullString) Then
			oOut.Write sStr
		End If
		Close
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message Tail"
	End Sub
	
	Sub Close()
		'********************************************************************************
		' Puropose : Write the common last lines of every user reply
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:Close"
		
		oOut.Close
		
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to close output: " & UserFile & ". The error was : " & Err.description & " (" & Err.number & ")"
			CmdProcessor.TerminateInSysErr
		Else
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] File: " & UserFile & " was successfully Closed."
		End If
		
		Set oOut = Nothing
	End Sub
	
	Sub WriteMsg (byVal sMessage, iPreSpace, iWordBreakStart)
		'********************************************************************************
		' Purpose : Build and Write a Formated string
		' Input   : string  : sMessage	    : the input string
		'			integer : preSpace	: the desired pre spaces to insert
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:WriteMsg"
		
		If Helper.IsNothing(oOut) Then 
			Initialize
		End If 
		
		If c_bSceneView Then
			aMultiLineMsg = Helper.BreakString(sMessage,vbNullString,c_iWidth - iPreSpace - 3,True, iWordBreakStart)
			For Each sLine In aMultiLineMsg
				sTmpStr = "|" & Space(iPreSpace) & sLine
				sTmpStr = Helper.BuildString(sTmpStr,(c_iWidth-1)) & "|"
				oOut.WriteLine sTmpStr
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message : " & sTmpStr
			Next
		Else
			aMultiLineMsg = Helper.BreakString(sMessage,vbNullString,c_iWidth - iPreSpace + 1,False, iWordBreakStart)
			For Each sLine In aMultiLineMsg
				sTmpStr = Space(iPreSpace) & sLine
				oOut.WriteLine sTmpStr
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message : " & sTmpStr
			Next
		End If
	End Sub
	
	Sub WriteMsgWithAppend (sMessage, sMessage2, iPreSpace, iWordBreakStart)
		'********************************************************************************
		' Purpose : Build and write a Formated string
		' Input   : string  : sMessage	    : the input string
		'			string  : sMessage2		: the string to append
		'			integer : iPreSpace	: the desired pre spaces to insert
		'********************************************************************************
		Dim currentSub : currentSub = "Class RaidenOutFile:WriteMsgWithAppend"
		
		If Helper.IsNothing(oOut) Then 
			Initialize
		End If 
		
		If c_bSceneView Then
			aMultiLineMsg = Helper.BreakString(sMessage,sMessage2,c_iWidth - iPreSpace - 3, True, iWordBreakStart)
			For Each sLine In aMultiLineMsg
				sTmpStr = "|" & Space(iPreSpace) & sLine
				sTmpStr = Helper.BuildString(sTmpStr,(c_iWidth-1)) & "|"
				oOut.WriteLine sTmpStr
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message : " & sTmpStr
			Next
		Else
			aMultiLineMsg = Helper.BreakString(sMessage,sMessage2,c_iWidth - iPreSpace + 1, False, iWordBreakStart)
			For Each sLine In aMultiLineMsg
				sTmpStr = Space(iPreSpace) & sLine
				oOut.WriteLine sTmpStr
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Write Message : " & sTmpStr
			Next
		End If
	End Sub
End Class

'######################################################################################
' Class Wrapper for Array Management
'######################################################################################
Class ArrayWrapper
	
	'Class vars
	Private  c_aArray(), c_iClassItems, c_sClassType, c_sClassName, c_oParent
	'Local vars
	Private bFound, iCnt, iSize, iGetSize, iLoopValue, sValue, element, aNewArray
	
	'#---------------------------------------------------------------------------#
	Private Sub Class_Initialize()
		c_sClassName	= "ArrayWrapper"
		c_iClassItems 	= 0
		c_sClassType  	= vbNullString
		Set c_oParent	= Nothing
	End Sub
	
	Private Sub Class_Terminate()
		'Nothing
	End Sub
	'#---------------------------------------------------------------------------#
	'Class Properties
	Public Property Get Size()
	If IsArray(c_aArray) Then
		Size = c_iClassItems
	End If
	End Property
	
	Public Property Get oType()
	If IsArray(c_aArray) Then
		oType = c_sClassType
	End If
	End Property
	
	Public Property Let oType(strType)
	c_sClassType = strType
	End Property
	
	Public Property Get Data()
	Data = c_aArray
	End Property
	
	Public Property Get Parent()
	Set Parent = c_oParent
	End Property
	
	Public Property Let Parent(oParent)
	Set c_oParent = oParent
	End Property
	'#---------------------------------------------------------------------------#
	
	Public Function GetIndexByValue(sStringToTest)
		'**********************************************************************************
		' Purpose : This function loops the array and returns the index depending on weither
		'           or not a string exists as one of the values within the array. 
		' Inputs	: string	: sStringToTest	: string	: the string to check
		' Return	: integer	: the index in the array if found / -1 If Not found
		'****************************************************************************
		
		'Init vars
		iLoopValue 	= 0
		GetIndexByValue 	= -1
		
		If c_iClassItems > 0 Then
			For Each element In c_aArray
				If IsArray(element) Then
					sValue = element(0)
				Else
					sValue = element
				End If
				
				'cast to string
				sValue = sValue & vbNullString
				sStringToTest = sStringToTest & vbNullString
				
				If LCase(sStringToTest) = LCase(sValue) Then
					GetIndexByValue = iLoopValue + 1
					Exit Function
				End If
				iLoopValue = iLoopValue + 1
			Next
		End If
	End Function
	
	Public Function GetIndexByValuePos(sStringToTest,iPos)
		'**********************************************************************************
		' Purpose : This function loops the array and returns the index depending on weither
		'           or not a string exists as one of the values within the array. 
		' Inputs	: string	: sStringToTest	: string	: the string to check
		' Return	: integer	: the index in the array if found / -1 If Not found
		'****************************************************************************
		
		'Init vars
		iLoopValue 	= 0
		GetIndexByValuePos 	= -1
		
		If c_iClassItems > 0 Then
			For Each element In c_aArray
				If IsArray(element) Then
					sValue = element(iPos)
				Else
					sValue = element
				End If
				
				'cast to string
				sValue = sValue & vbNullString
				sStringToTest = sStringToTest & vbNullString
				
				If LCase(sStringToTest) = LCase(sValue) Then
					GetIndexByValuePos = iLoopValue + 1
					Exit Function
				End If
				iLoopValue = iLoopValue + 1
			Next
		End If
	End Function
	
	Public Function AddItem(sElement)
		'**********************************************************************************
		' Purpose : This function will Add the specified element to the array
		' Inputs	: string	: sElement	: the string element to add
		' Return	: integer	: OK = True / Error = false
		'**********************************************************************************
		
		On Error Resume Next
		
		'Detect the not initialized array
		If c_iClassItems = 0 Then
			ReDim c_aArray(0)
			c_aArray(0) = sElement
		Else
			ReDim Preserve c_aArray(c_iClassItems)
			c_aArray(c_iClassItems) = sElement
		End If
		
		c_iClassItems = c_iClassItems + 1
		
		If Err.Number <> 0 Then
			WScript.echo Err.Number & " : " & Err.Description
			AddItem = False
		Else 
			AddItem = True
		End If
		
		'Fire an event
		If (TypeName(FIRE_CLASS_EVENTS) <> "Nothing") Then
			If (FIRE_CLASS_EVENTS = True) Then
				Class_FireEvent "ArrayWrapper:" & c_sClassType, "AddItem", AddItem, sElement
			End If
		End If 
	End Function
	
	Public Function Clear()
		'**********************************************************************************
		' Purpose : This function will Reset the array
		' Inputs	: none
		'**********************************************************************************
		Erase c_aArray 
		c_iClassItems = 0
		
		'Detect Error
		If Err.Number <> 0 Then
			WScript.echo Err.Number & " : " & Err.Description
			Clear = False
		Else 
			Clear = True
		End If
		'clear the error state
		Err.Clear
		
		'Fire an event
		If (TypeName(FIRE_CLASS_EVENTS) <> "Nothing") Then
			If (FIRE_CLASS_EVENTS = True) Then
				Class_FireEvent "ArrayWrapper:" & c_sClassType, "Clear", Clear, vbNullString
			End If
		End If 
	End Function
	
	Public Function UpdateItem(index,sElement)
		'**********************************************************************************
		' Purpose 	: This function will Update the specified element to the array
		' Inputs	: integer 	: index 	: the index to edit
		'			  string	: sElement	: the string element to add
		' Return	: integer	: OK = True / Error = false
		'**********************************************************************************
		
		'init vars
		UpdateItem = False
		
		'Detect the not initialized array
		If c_iClassItems = 0 Then
			UpdateItem = False
		ElseIf ((index <= (c_iClassItems)) And (index > 0)) Then
			c_aArray(index-1) = sElement
			UpdateItem = True
		End If
		
		'Fire an event
		If (TypeName(FIRE_CLASS_EVENTS) <> "Nothing") Then
			If (FIRE_CLASS_EVENTS = True) Then
				Class_FireEvent "ArrayWrapper:" & c_sClassType,"UpdateItem", UpdateItem, index & ":" & Join(sElement,"|")
			End If
		End If 
	End Function
	
	Public Function DeleteItemByIndex(iElementIndex)
		'**********************************************************************************
		' Purpose 	: This function will delete the specified element from the array
		' Inputs	: integer	: iElementIndex	: the index of the element to delete
		'**********************************************************************************
		
		'init vars
		aNewArray 			= Empty
		sValue				= Empty
		bFound 				= False
		DeleteItemByIndex 	= False
		iLoopValue 			= 1
		
		iSize = GetSize(c_aArray)
		
		If ((iElementIndex <= (iSize)) And (iElementIndex > 0))Then 
			'extract the array data
			For Each element In c_aArray
				If iLoopValue <> iElementIndex Then
					iSize = GetSize(aNewArray)
					If iSize = 0 Then
						ReDim aNewArray(0) : aNewArray(0) = element 
					Else
						ReDim Preserve aNewArray(iSize) : aNewArray(iSize) = element
					End If
				Else 
					bFound = True
				End If
				iLoopValue = iLoopValue + 1
			Next
			
			'write the data
			If (bFound = True) Then
				iSize = GetSize(aNewArray)
				If (iSize >= 1) Then
					'Set the new values
					ReDim c_aArray(iSize-1)
					
					iLoopValue  = 0
					For Each element In aNewArray
						c_aArray(iLoopValue) = element
						iLoopValue = iLoopValue + 1
					Next
					c_iClassItems = iSize
				Else
					Erase c_aArray
					c_iClassItems = 0
				End If
				DeleteItemByIndex = True
			End If
		End If 
		
		If Err.Number <> 0 Then
			WScript.echo Err.Number & " : " & Err.Description
		End If 
		
		'clear the error state
		Err.Clear
		
		If (TypeName(FIRE_CLASS_EVENTS) <> "Nothing") Then
			If (FIRE_CLASS_EVENTS = True) Then
				Class_FireEvent "ArrayWrapper:" & c_sClassType,"DeleteIndex", DeleteItemByIndex, iElementIndex
			End If
		End If 
	End Function
	
	Public Function DeleteItemByValue(Value)
		'**********************************************************************************
		' Purpose : This function will delete the specified element from the array
		' Inputs	: string	: sElement	: the string Item to delete
		' Return	: integer	: OK = True / Error = false
		'**********************************************************************************
		
		'set the default output
		aNewArray 			= Empty
		sValue				= Empty
		bFound 				= False
		DeleteItemByValue 	= False
		iLoopValue 			= 0
		
		'Find the element
		For Each element In c_aArray
			If IsArray(element) Then
				sValue = element(0)
			Else
				sValue = element
			End If	
			
			'cast to string
			sValue 	= sValue & vbNullString
			Value 	= Value & vbNullString	
			
			If LCase(sValue) <> LCase(Value) Then
				iSize = GetSize(aNewArray)
				If iSize = 0 Then
					ReDim aNewArray(0) : aNewArray(0) = element 
				Else
					ReDim Preserve aNewArray(iSize) : aNewArray(iSize) = element
				End If
			Else 
				bfound = True
			End If
		Next
		
		' write the data
		If (bfound = True) Then
			iSize = GetSize(aNewArray)
			If (iSize >= 1) Then
				'Set the new values
				ReDim c_aArray(iSize-1)
				
				iLoopValue = 0
				For Each element In aNewArray
					c_aArray(iLoopValue) = element
					iLoopValue = iLoopValue + 1
				Next
				c_iClassItems = iSize
			Else
				Erase c_aArray
				c_iClassItems = 0
			End If 
			DeleteItemByValue = True
		End If 
		
		If Err.Number <> 0 Then
			WScript.echo Err.Number & " : " & Err.Description
			Err.Clear
		End If 
		
		If (TypeName(FIRE_CLASS_EVENTS) <> "Nothing") Then
			If (FIRE_CLASS_EVENTS = True) Then
				Class_FireEvent "ArrayWrapper:" & c_sClassType,"DeleteItem", DeleteItemByValue, Value
			End If 
		End If 
	End Function
	
	Public Function DeleteItemByValuePos(Value,iPos)
		'**********************************************************************************
		' Purpose : This function will delete the specified element from the array
		' Inputs	: string	: sElement	: the string Item to delete
		' Return	: integer	: OK = True / Error = false
		'**********************************************************************************
		
		'set the default output
		aNewArray 			= Empty
		sValue				= Empty
		bFound 				= False
		DeleteItemByValuePos 	= False
		iLoopValue 			= 0
		
		'Find the element
		For Each element In c_aArray
			If IsArray(element) Then
				sValue = element(iPos)
			Else
				sValue = element
			End If	
			
			'cast to string
			sValue 	= sValue & vbNullString
			Value 	= Value & vbNullString	
			
			If LCase(sValue) <> LCase(Value) Then
				iSize = GetSize(aNewArray)
				If iSize = 0 Then
					ReDim aNewArray(0) : aNewArray(0) = element 
				Else
					ReDim Preserve aNewArray(iSize) : aNewArray(iSize) = element
				End If
			Else 
				bfound = True
			End If
		Next
		
		' write the data
		If (bfound = True) Then
			iSize = GetSize(aNewArray)
			If (iSize >= 1) Then
				'Set the new values
				ReDim c_aArray(iSize-1)
				
				iLoopValue = 0
				For Each element In aNewArray
					c_aArray(iLoopValue) = element
					iLoopValue = iLoopValue + 1
				Next
				c_iClassItems = iSize
			Else
				Erase c_aArray
				c_iClassItems = 0
			End If 
			DeleteItemByValuePos = True
		End If 
		
		If Err.Number <> 0 Then
			WScript.echo Err.Number & " : " & Err.Description
			Err.Clear
		End If 
		
		If (TypeName(FIRE_CLASS_EVENTS) <> "Nothing") Then
			If (FIRE_CLASS_EVENTS = True) Then
				Class_FireEvent "ArrayWrapper:" & c_sClassType,"DeleteItem", DeleteItemByValue, Value
			End If 
		End If 
	End Function
	
	Public Function GetItemByIndex(iElementIndex)
		'**********************************************************************************
		' Purpose : This function will return the specified element from the array
		' Inputs	: integer	: iElementIndex	: the index of the element search for
		'**********************************************************************************
		'init vars
		GetItemByIndex = Empty
		
		If ((iElementIndex <= (c_iClassItems)) And (iElementIndex > 0)) Then
			GetItemByIndex = c_aArray(iElementIndex-1)
		End If
	End Function
	
	Public Function GetItemByValue(ElementValue)
		'**********************************************************************************
		' Purpose : This function will return the specified element from the array
		' Inputs	: integer	: ElementValue	: the value of the element to search for
		'**********************************************************************************
		GetItemByValue = Empty
		
		For Each element In c_aArray
			If IsArray(element) Then
				sValue = element(0)
			Else
				sValue = element
			End If	
			
			'cast to string
			sValue = sValue & vbNullString
			ElementValue = ElementValue & vbNullString	
			
			If (LCase(sValue) = LCase(ElementValue)) Then
				GetItemByValue = element
				Exit Function	
			End If
		Next
	End Function
	
	Public Function GetItemByValuePos(ElementValue,iPos)
		'**********************************************************************************
		' Purpose : This function will return the specified element from the array
		' Inputs	: integer	: ElementValue	: the value of the element to search for
		'**********************************************************************************
		GetItemByValuePos = Empty
		
		For Each element In c_aArray
			If IsArray(element) Then
				sValue = element(iPos)
			Else
				sValue = element
			End If	
			
			'cast to string
			sValue = sValue & vbNullString
			ElementValue = ElementValue & vbNullString	
			
			If (LCase(sValue) = LCase(ElementValue)) Then
				GetItemByValuePos = element
				Exit Function	
			End If
		Next
	End Function
	
	Private Function GetSize(aArray)
		'#--------------------------------------------------------------------------------#
		' Purpose : Check the array size
		'#--------------------------------------------------------------------------------#	
		On Error Resume Next
		iGetSize = UBound(aArray)
		
		If Err.Number Then
			If ((Err.Number = 9) Or(Err.Number = 13)) Then
				iGetSize = 0
			End If
		Else
			iGetSize = UBound(aArray) + 1
		End If
		On Error Goto 0
		GetSize = iGetSize
	End Function 
	
	Private Function Class_FireEvent (sSource, sEventType, bResult, aValues)
		'#--------------------------------------------------------------------------------#
		' Purpose : Fire an event
		'#--------------------------------------------------------------------------------#	
		If TypeName(c_oParent) <> "Nothing" Then 
			c_oParent.Class_Event sSource, sEventType, bResult, aValues
		End If 
	End Function
End Class

'######################################################################################
' Class Wrapper for Logging
'######################################################################################
Class UserLogClass
	
	Private bLoaded, bLogActive
	Private	sLogRoot,sLog
	Private oShell,oFso,oRegEx,oLog,oFldr,oFile
	Private iLogToKeep,iArr,iCnt,n,m,temp
	Private	aLog,aDate
	Private cFiles
	
	Private Sub Class_Initialize
		'#--------------------------------------------------------------------------------#
		' Purpose : Class Initialisation
		'#--------------------------------------------------------------------------------#	
		iLogToKeep	= NUMBEROFLOGS
		bLoaded		= False
		bLogActive	= False
		sLogRoot 	= SCRIPTPATH & "\Log"
		Set oShell 	= WScript.CreateObject("Wscript.Shell")
		Set oFso	= CreateObject("Scripting.FileSystemObject")
	End Sub
	
	Private Sub Class_Terminate
		'#--------------------------------------------------------------------------------#
		' Purpose : Class Terminate
		'#--------------------------------------------------------------------------------#	
		Dim currentSub : currentSub = "Class UserLog:Class_Terminate"
		
		'Clean up the logs
		DelLog
		
		Set oFso	= Nothing
		Set oShell	= Nothing
	End Sub
	
	Public Property Get LogPath()
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	LogPath = sLogRoot
	End Property
	
	Public Property Let LogPath(sPath)
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	If sPath <> vbNullString Then
		sLogRoot = sPath
	End If 
	End Property
	
	Public Property Get LogActive()
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	LogActive = bLogActive
	End Property
	
	Public Property Get LogsToKeep()
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	LogsToKeep = iLogToKeep
	End Property
	
	Public Property Let LogsToKeep(iValue)
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	If (VarType(iValue) = vbInteger) Then
		iLogToKeep = iValue
	End If 
	End Property
	
	Public Property Get LogFile()
	'#--------------------------------------------------------------------------------#
	' Purpose	: This function sets the file path
	'#--------------------------------------------------------------------------------#
	LogFile = sLog
	End Property
	
	Public Function Start()
		'**********************************************************************************
		' Purpose : Initialize the Log interface, check log path
		'           Easily extend logging into other formats, Ex : Syslog, mail, xml etc.
		' Input   : none
		' Return  : bool	: True|False
		'**********************************************************************************
		Dim currentSub : currentSub = "ClassUserLog:Start"
		
		If (Helper.CreateFolder(sLogRoot) <> True) Then
			LogEvent ERRORL, ABORT
			WScript.quit
		End If
		
		sLog = sLogRoot & "\" & Helper.GetDayTimeDate() & ".log"
		If (oFso.FileExists(sLog)) Then
			LogEvent INFORMATION, "[" & currentSub & "] The logfile: " & sLog & " allready exists. Appending random number to name of logfile"
			sLog = sLogRoot & "\" & Helper.GetDayTimeDate() & "_" & Helper.Random(9999) & ".log"
		End If
		
		LogEvent INFORMATION, "[" & currentSub & "] Logfile = " & sLog
		
		Set oLog = oFso.OpenTextFile(sLog, FORAPPENDING, True)
		
		bLogActive = True
	End Function
	
	Public Sub LogEvent(eventType, sMessage)
		'**********************************************************************************
		' Purpose : Log interface, write various type of events to different formats, 
		'			NT Event, File etc.
		'           Easily extend logging into other formats, Ex : Syslog, mail, xml etc.
		' Input   : i : Event type, Integer 0 = None 1 = Success/Error 2 = Full
		'           sMessage : Log message, String
		'**********************************************************************************
		'Eventlog output
		If EVENTLOG = 1 Or EVENTLOG = 2 Then
			Set oRegEx = New RegExp
			'oRegEx.Pattern = "\[.*\] "
			'Changed to be able to print message file output when Message contains Brackets]
			oRegEx.Pattern = "^(\[[^*\]]*\])+"
			sMessage = oRegEx.Replace (sMessage, "")
			doEventLog eventType, Trim(sMessage)
			Set oRegEx = Nothing
		End If
		
		'Debug EventLog output
		If EVENTLOG = 3 Then
			doEventLog eventType, sMessage
		End If
		
		'Logfile output
		If FILELOG = 1 Or FILELOG = 2 Then
			Set oRegEx = New RegExp
			'oRegEx.Pattern = "\[.*\] "
			'Changed to be able to print message file output when Message contains Brackets]
			oRegEx.Pattern = "^(\[[^*\]]*\])+"
			sMessage = oRegEx.Replace (sMessage, "")
			doFileLog eventType, Trim(sMessage)
			Set oRegEx = Nothing
		End If
		
		'Debug logfile output
		If FILELOG = 3 Then
			doFileLog eventType, sMessage
		End If	
		
		'Debug screen output
		If FILELOG = 3 Or EVENTLOG = 3 Then
			WScript.echo sMessage
		End If
	End Sub
	
	Private Sub doFileLog(eventType, sMessage)
		'**********************************************************************************
		' Purpose : Write Event to logfile. Build an array of events until path logfile 
		'			is determined.
		'           If logfile can not be written. Events are redirected to eventlog.
		'           EventLog Level 0 = None 1 = Success/Error 2 = Full
		' Input   : eventType : Event type, Integer
		'           0 SUCCESS	1 ERROR (Const ERRORL)	2 WARNING	4 INFORMATION
		'           s : Log message, String
		' Use     : bLog Boolean True|False when actually start logging to file
		'**********************************************************************************
		On Error Resume Next
		
		Dim currentSub : currentSub = "Class UserLog:FileLog"
		
		'WScript.Echo eventType & " : " & sMessage
		'Make sure errorlevel 0
		Err.clear
		
		'Log to file if bLog flag is true
		If bLogActive = True Then
			
			'moved to initialize
			'Set oLog = oFso.OpenTextFile(sLog, FORAPPENDING, True)
			
			If Err.number <> 0 Then
				Helper.EchoErr Err, currentSub
				'Clear error
				Err.clear
				'Check if log folder exists, try to create
				If Helper.CreateFolder(Left(sLog, InStrRev(sLog, "\"))) Then
					Set oLog = oFso.OpenTextFile(sLog, FORAPPENDING, True)
					
				Else
					
					'Abort filelog operation if can't be written, switch to EventLog	
					EVENTLOG = 2
					FILELOG = 0
					Err.Raise = iErr
					LogEvent ERRORL, "[" & currentSub & "] Error occured while writing to logfile: " & sLog & ". The error was: " & Err.description
					LogEvent WARNING, "[" & currentSub & "] Events will permanently be redirected to eventlog. All events occured prior to this warning will now be written."
					
					'Write events from array to eventlog
					If IsArray(aLog) And aLog(0) <> vbNullString Then
						For iArr = 0 To UBound(aLog)
							LogEvent CInt(Left(aLog(iArr), 1)), Right(aLog(iArr), Len(aLog(iArr)) - 1)
						Next
						
						ReDim aLog(0)	
					End If
					
					Exit Sub
				End If
			End If
			
			'Write events from array to logfile
			If IsArray(aLog) And aLog(0) <> vbNullString Then
				For iArr = 0 To UBound(aLog)
					oLog.WriteLine Right(aLog(iArr), Len(aLog(iArr)) - 1)
				Next
				
				ReDim aLog(0)
			End If
			
			Select Case FILELOG
				Case 1
				Select Case eventType
					Case SUCCESS
					oLog.WriteLine Now & " SUCCESS " & sMessage
					Case ERRORL
					oLog.WriteLine Now & " ERROR   " & sMessage
					Case Else
					'Exit Sub 
				End Select
				Case 2
				Select Case eventType
					Case SUCCESS
					oLog.WriteLine Now & " SUCCESS     " & sMessage
					Case ERRORL
					oLog.WriteLine Now & " ERROR       " & sMessage
					Case WARNING
					oLog.WriteLine Now & " WARNING     " & sMessage
					Case INFORMATION
					oLog.WriteLine Now & " INFORMATION " & sMessage
					Case Else
					'Exit Sub
				End Select
				Case 3
				Select Case eventType
					Case SUCCESS
					oLog.WriteLine Now & " SUCCESS     " & sMessage
					Case ERRORL
					oLog.WriteLine Now & " ERROR       " & sMessage
					Case WARNING
					oLog.WriteLine Now & " WARNING     " & sMessage
					Case INFORMATION
					oLog.WriteLine Now & " INFORMATION " & sMessage
					Case Else
					'Exit Sub
				End Select
				Case Else
				Exit Sub
			End Select
			
			'moved to dellog
			'oLog.close
			'Set oLog = Nothing
		Else
			
			'Log to array while path to logfile determined
			If IsArray(aLog) Then
				iArr = UBound(aLog) + 1
				ReDim Preserve aLog(iArr)
			Else
				ReDim aLog(0)
				iArr = UBound(aLog)
			End If
			
			Select Case FILELOG
				Case 1
				Select Case eventType
					Case SUCCESS
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " SUCCESS " & sMessage
					Case ERRORL
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " ERROR   " & sMessage
					Case Else
					ReDim Preserve aLog(iArr-1)
					Exit Sub
				End Select
				Case 2
				Select Case eventType
					Case SUCCESS
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " SUCCESS     " & sMessage
					Case ERRORL
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " ERROR       " & sMessage
					Case WARNING
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " WARNING     " & sMessage
					Case INFORMATION
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " INFORMATION " & sMessage
					Case Else
					Exit Sub
				End Select
				Case 3
				Select Case eventType
					Case SUCCESS
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " SUCCESS     " & sMessage
					Case ERRORL
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " ERROR       " & sMessage
					Case WARNING
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " WARNING     " & sMessage
					Case INFORMATION
					ReDim Preserve aLog(iArr)
					aLog(iArr) = eventType & Now & " INFORMATION " & sMessage
					Case Else
					Exit Sub
				End Select
				Case Else
				Exit Sub
			End Select
		End If
	End Sub
	
	Private Sub doEventLog(eventType, sMessage)
		'********************************************************************************
		' Purpose : Write Event to Eventlog.
		'           EventLog Level 0 = None 1 = Success/Error 2 = Full
		' Input   : eventType : Event type, Integer
		'           0 SUCCESS 1 ERROR (Const ERRORL) 2 WARNING 4 INFORMATION
		'           sMessage : Log message, String
		'********************************************************************************
		Select Case EVENTLOG
			Case 1
			Select Case eventType
				Case SUCCESS
				oShell.LogEvent eventType, sMessage
				Case ERRORL
				oShell.LogEvent eventType, sMessage
				Case Else
				Exit Sub
			End Select
			Case 2
			Select Case eventType
				Case SUCCESS
				oShell.LogEvent eventType, sMessage
				Case ERRORL
				oShell.LogEvent eventType, sMessage
				Case WARNING
				oShell.LogEvent eventType, sMessage
				Case INFORMATION
				oShell.LogEvent eventType, sMessage
				Case Else
				Exit Sub
			End Select
			Case 3
			Select Case i
				Case SUCCESS
				oShell.LogEvent eventType, sMessage
				Case ERRORL
				oShell.LogEvent eventType, sMessage
				Case WARNING
				oShell.LogEvent eventType, sMessage
				Case INFORMATION
				oShell.LogEvent eventType, sMessage
				Case Else
				Exit Sub
			End Select
			Case Else
			Exit Sub
		End Select
	End Sub
	
	Private Sub DelLog()
		'**********************************************************************************
		' Purpose : Delete obsolete logs
		' Input   : None
		'**********************************************************************************
		Dim currentSub : currentSub = "Class UserLog:DelLog"
		Dim sProcessTime,tEndTime
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] Log CleanUP Started"
		
		If iLogToKeep <> 0 Then
			LogEvent INFORMATION, "[" & currentSub & "] Call KeepOnlyFiles " & sLogRoot & " " & iLogToKeep
			KeepOnlyFiles sLogRoot, iLogToKeep
		End If
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] Log CleanUP Complete"
		
		tEndTime = Timer()
		sProcessTime = ((tEndTime - tStartTime)*1000)
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] " & APPNAME & " " & APPVERMAJOR &  "." & APPVERMINOR & " ended successfully in " & sProcessTime & " milliseconds"
		
		'Close the log file
		oLog.close
	End Sub
	
	Private Sub KeepOnlyFiles(sPath, iCount)
		'**********************************************************************************
		' Purpose : Delete obsolete files based upon date.
		'           n newest files are kept.
		' Input   : String (s) Path to root of files
		'           Integer : iCount : Number of folders to keep
		'**********************************************************************************
		On Error Resume Next
		
		Dim cFiles
		Dim currentSub : currentSub = "Class UserLog:KeepOnlyFiles"
		
		Set oFldr = oFso.GetFolder(sPath)
		Helper.EchoErr Err, currentSub
		
		If Err.number <> 0 Then
			LogEvent ERRORL, "[" & currentSub & "] An Error occured connecting to: " & sPath & " old files must be deleted manually."
			Exit Sub
		Else
			LogEvent INFORMATION, "[" & currentSub & "] Connected to: " & sPath
		End If
		
		Set cFiles = oFldr.Files
		Helper.EchoErr Err, currentSub
		
		If Err.number <> 0 Then
			LogEvent ERRORL, "[" & currentSub & "] An Error occured while listing files in folder: " & sPath & ". Old files must be deleted manually."
			Exit Sub
		Else
			LogEvent INFORMATION, "[" & currentSub & "] Succsessfully listed files in folder: " & sPath
		End If
		
		'Check if number of files greater than i
		If cFiles.Count <= iCount Then
			LogEvent INFORMATION, "[" & currentSub & "] Number of file(s) in root is: " & cFiles.Count & ". Number is less or equal to: " & iCount & " wich is the number of file(s) to keep."
			Exit Sub
		End If
		
		LogEvent INFORMATION, "[" & currentSub & "] Number of files in root is: " & cFiles.Count & ". Number is greater: " & iCount & " wich is the number of file(s) to keep."
		
		'ReDim array to number of folders
		ReDim aDate(cFiles.Count -1)
		
		LogEvent INFORMATION, "[" & currentSub & "] Creating array with fixed size: " & cFiles.Count -1 & ". Adding date of folders to array"
		
		iCnt = 0
		
		'Add date creation of all folders to array
		For Each oFile In cFiles
			LogEvent INFORMATION, "[" & currentSub & "] aDate(" & iCnt & ") = " & oFile.DateCreated & " (Path: " & oFile.Path & ")"
			aDate(iCnt) = oFile.DateCreated
			iCnt = iCnt + 1
		Next
		
		'Sorting array by date, ascent sort order (The famous bubble sort)
		LogEvent INFORMATION, "[" & currentSub & "] Sorting dates in array, ascent sort order"
		For n = 0 To UBound(aDate) -1 
			For m = n+1 To UBound(aDate) 
				If aDate(m) < aDate(n) Then
					temp = aDate(m)
					aDate(m) = aDate(n)
					aDate(n) = temp
				End If
			Next
		Next
		
		'Just logging
		LogEvent INFORMATION, "[" & currentSub & "] Array sorted, result in ascent order: "
		For iCnt = 0 To UBound(aDate)
			LogEvent INFORMATION, "[" & currentSub & "] aDate(" & iCnt & ") = " & aDate(iCnt)
		Next
		
		'Cut array, keep (i) rows with date of folders wich is going to be deleted
		ReDim Preserve aDate(UBound(aDate) - iCount)
		LogEvent INFORMATION, "[" & currentSub & "] Array aDate cut, remaing rows are: "
		
		'Even more logging (those debuggers ;))
		For iCnt = 0 To UBound(aDate)
			LogEvent INFORMATION, "[" & currentSub & "] aDate(" & iCnt & ") = " & aDate(iCnt)
		Next
		
		LogEvent INFORMATION, "[" & currentSub & "] Start deleting file(s)..."
		
		For Each oFile In cFiles
			For iCnt = 0 To UBound(aDate)
				If oFile.DateCreated = aDate(iCnt) Then
					LogEvent INFORMATION, "[" & currentSub & "] aDate(" & iCnt & ") = " & aDate(iCnt) & " matches DateCreated on file: " & oFile.Path & " (Date=" & oFile.DateCreated & ")"
					Helper.DeleteFile oFile.Path
					Exit For
				End If
			Next
		Next
		
		Helper.EchoErr Err, currentSub
		
		If Err.Number = 0 Then
			LogEvent SUCCESS, "[" & currentSub & "] Deleted " & UBound(aDate)+1 & " obsolete log files" 
		End If
		
	End Sub
End Class

Public Function ChangeOwner(sMode, sUser, sGroup, sItemPath, bRecursive)
	'********************************************************************************
	' Purpose : change owner on file and folders (For raidenFTPD)
	' Input   : sMode	   : the mode in xxx format (ie: 744 or 777)
	'           sUser	   : the new owner (user)
	'           sGroup	   : the new owner (group)
	'           sItemPath  : The path where to start
	'           bRecursive : Shoule the operation be recurcive [True|False]
	'********************************************************************************
	Dim currentSub : currentSub = "Class CmdProcessorClass:ChangeOwner"
	Dim sCmdRun, oFolder, Folder

	Set oFolder = Helper.oFso.GetFolder(sItemPath)
		
	sCmdRun = Chr(34) & SCRIPTPATH & "\tools\chmod.exe" & Chr(34)
	sCmdRun = sCmdRun & " " & sMode & " " & sUser & " " & sGroup & " "
	Helper.ShellRun sCmdRun & Chr(34) & sItemPath & Chr(34),0,true,""
	Helper.ShellRun sCmdRun & Chr(34) & sItemPath & "\*" & Chr(34),0,true,""
	
	If bRecursive Then
		for each Folder in oFolder.Subfolders        
			ChangeOwner sMode,sUser,sGroup,folder.Path,bRecursive   
		Next
	End if 
End Function
	
'######################################################################################
' Class Wrapper for RaidenFTPD Command Processor
'######################################################################################
Class CmdProcessorClass

	'local vars
	Private sGroupHelp, sGroupHelp2, sItem, sUser, sNewMsg
	Private aUsers, aItems ,aItem
	Private iItemCnt,iNewItemCnt
	Private bNewFound
	Private item

	Sub CommandDispatcher()
		'********************************************************************************
		' Puropose : Dispatch the command
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:CommandDispatcher"
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] Command Dispatcher Started"
		
		'Check if user has requested help
		If LCase(cmdCMD) = "help" And LCase(cmdSITECMD) = "request" Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] User has requested help, call TerminateInHlp()"
			TerminateInHlp
		End If
		
		'Check if user has requested list
		If LCase(cmdCMD) = "" And LCase(cmdSITECMD) = "request" Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] User requested : List Requests, call TerminateInList()"
			TerminateInList
		End If
		
		'Check if user has requested fill
		If LCase(cmdCMD) <> "" And LCase(cmdSITECMD) = "reqfilled" Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] User requested : FILL Request, call TerminateinFill()"
			If (((REQUEST_FILL_OPS_ONLY = True) And (cmdLEVEL = 1)) Or (REQUEST_FILL_OPS_ONLY = False)) Then
				TerminateInFill
			Else
				TerminateInMsg currentSub, ERRORL ,"You do not have access to Fill command."
			End If 
		End If
		
		'Check if user has requested add
		If LCase(cmdCMD) <> "" And LCase(cmdSITECMD) = "request" Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] User requested : ADD request message, call TerminateInAddRequest()"
			If (((REQUEST_ADD_OPS_ONLY = True) And (cmdLEVEL = 1)) Or (REQUEST_ADD_OPS_ONLY = False)) Then
				TerminateInAdd
			Else
				TerminateInMsg currentSub, ERRORL ,"You do not have access to Add command."
			End If 
		End If
		
		'Check if user has requested delete
		If LCase(cmdCMD) <> "" And LCase(cmdSITECMD) = "reqdel" Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] User requested : ADD request message, call TerminateInAddRequest()"
			If (((REQUEST_DELETE_OPS_ONLY = True) And (cmdLEVEL = 1)) Or (REQUEST_DELETE_OPS_ONLY = False)) Then
				TerminateInDelete
			Else
				TerminateInMsg currentSub, ERRORL ,"You do not have access to Delete command."
			End If 
		End If
		
		'If we get here it means that the command was not recognized
		UserLog.LogEvent ERRORL, "[" & currentSub & "] User requested : Unknown Command : [" & cmdCMD & "]. call TerminateInHlp()"
		TerminateInHlp
	End Sub
	
	Sub TerminateInHlp()
		'********************************************************************************
		' Puropose : Terminate the script, write help output to user
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:TerminateInHlp"
		
		sGroupHelp 	= vbNullString 
		sGroupHelp2 = vbNullString
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] HELP Command Process Started"
		
		RaidenOutFile.WriteMsgHeader
		RaidenOutFile.WriteMsg "Syntax : site <command> <title> ",1,1
		RaidenOutFile.WriteMsgSeparator
		RaidenOutFile.WriteMsg "Commands :",1,1
		RaidenOutFile.WriteMsg     "request           : List all current Requests",4,1
		If (((REQUEST_ADD_OPS_ONLY = True) And (cmdLEVEL = 1)) Or (REQUEST_ADD_OPS_ONLY = False)) Then
			RaidenOutFile.WriteMsg "request <title>   : Add a Request for the <title>",4,1
		End if
	    If (((REQUEST_DELETE_OPS_ONLY = True) And (cmdLEVEL = 1)) Or (REQUEST_DELETE_OPS_ONLY = False)) Then
			RaidenOutFile.WriteMsg "reqdel <title>    : Delete the Request for <title>",4,1
		End If
		If (((REQUEST_FILL_OPS_ONLY = True) And (cmdLEVEL = 1)) Or (REQUEST_FILL_OPS_ONLY = False)) Then
			RaidenOutFile.WriteMsg "reqfilled <title> : Fill the Request for <title>",4,1
		End If
		RaidenOutFile.WriteMsg     "request help      : Show this help",4,1
		RaidenOutFile.WriteMsgTail
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] HELP Command Process Completed"	
		
		'terminate
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.Quit
	End Sub

	Sub TerminateInAdd()
		'********************************************************************************
		' Puropose : Process the add command, Terminate the script, 
		'            write output to user
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:TerminateInAdd"
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] AddItem Command Process Started"
		'On Error Resume next
		
		'check if we have all the inputs
		If (oArgs.Count < 7) Then
			TerminateInMsg currentSub, ERRORL ,"Request Add is missing parameter(s)"
		End If 
		
		'load the full string
		sItem = oArgs(6)
		For iCnt = 7 To oArgs.Count -1
			sItem = sItem & " " & oArgs(iCnt)
		Next
		
		'load the store file
		RaidenReqStoreFile.Server = cmdSERVER
		RaidenReqStoreFile.load
		
		If RaidenReqStoreFile.Count < REQUEST_MAX_LIMIT then
			'Check and Add
			If Not(RequestExists(sItem)) And Helper.FolderNotExists(REQUEST_FILLED_FOLDER & "\" & REQUEST_HEAD_FILLED & sItem, False) Then
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Adding Request: " & sItem
				
				'Create the Req folder
				If Helper.CreateFolder(BuildFolderPath(sItem)) Then
					'change Ownership
					If REQUEST_CHMODE Then
						ChangeOwner REQUEST_MODE_REQUEST,cmdUSER,cmdUSERGRP,BuildFolderPath(sItem),True
						UserLog.LogEvent SUCCESS, "[" & currentSub & "] Folder Ownership was Updated to User:" & SITECMD & " Group:" & "script" & " Mode:" & REQUEST_MODE_REQUEST
					End If
				Else
					UserLog.LogEvent INFORMATION, "[" & currentSub & "] Unable to create folder " & BuildFolderPath(sItem)
				End If
				
				'Add the Request
				RaidenReqStoreFile.AddItem cmdSERVER, cmdUSER, cmdUSERGRP, "ftpd", sItem
	
				'Write the Command Output if it is user command only
				PostMessage RaidenOutFile, "Added: " & sItem
				
				'post the request message file
				If REQUEST_MSGFILE_ENABLE Then
					SaveToMessageFile "request"
				End If 
				
				'post the Directory message file
				If REQUEST_DIRMSGFILE_ENABLE Then
					SaveToDirFile "request", REQUEST_FOLDER & "\" & REQUEST_DIRMSGFILE_NAME
				End If 
			Else
				PostMessage RaidenOutFile, "Request allready exists OR has allready been filled"
			End If
		Else
			PostMessage RaidenOutFile, "Requests has reached maximum limit of " & REQUEST_MAX_LIMIT & " Active requests."
		End If 		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] ADD Request Command Process Completed"
		
		'terminate
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.Quit
	End Sub
		
	Sub TerminateInlist()
		'********************************************************************************
		' Puropose : Process Read Command, Terminate the script, 
		'            write help output to user
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:TerminateInRead"
		Dim aTemplate, sOutMsg
		
		'init vars
		iItemCnt 		= 0
		iNewItemCnt 	= 0
		aItems    	    = Empty
				
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] READ Command Process Started"
		
		aItems      = RaidenReqStoreFile.ReadItems(cmdSERVER)
		iItemCnt	= RaidenReqStoreFile.Count
		

		RaidenOutFile.CmdType 	= "siteCommand"
		'output the nfo		
		If REQUEST_LIST_NFO <> vbNullString Then
			aTemplate = Helper.ReadFile(SCRIPTPATH & "\Nfo\" & REQUEST_LIST_NFO)
		
			If UBound(aTemplate) > 0 Then
				'process the lines
				For iCnt = 0 To UBound(aTemplate)
					If iCnt = 0 Then
						sOutMsg   = aTemplate(iCnt)
					Else
						sOutMsg   = sOutMsg & vbcrlf & aTemplate(iCnt)
					End if
					
				Next
			
				'Finally write the output Nfo
				RaidenOutFile.WriteNFO sOutMsg, True
				RaidenOutFile.WriteMsgHeaderNoResult
			Else
				UserLog.LogEvent ERRORL, "[" & currentSub & "] Missing NFO Template file: " & SCRIPTPATH & "\Nfo\" & REQUEST_LIST_NFO
				RaidenOutFile.WriteMsgHeader
			End If
		Else
			RaidenOutFile.WriteMsgHeader
		End If 
		
		If iItemCnt > 0 then
			'Post the Command Output
			iItemCnt = 1
			iNewItemCnt = 0
			RaidenOutFile.SceneView = False
			RaidenOutFile.Width     = 300
			For Each aItem In aItems
				RaidenOutFile.WriteMsgWithAppend "[" & Helper.BuildString (iItemCnt,Len(REQUEST_MAX_LIMIT)) & "] " & aItem(6), "~ by " & aItem(3) & " (" & aItem(5) & ") at " & aItem(1),1,10 
				iItemCnt = iItemCnt + 1
			Next
			RaidenOutFile.SceneView = SCENEVIEW
			RaidenOutFile.Width     = WIDTH
		Else
			RaidenOutFile.WriteMsg "No Requests",1,1
		End if
		RaidenOutFile.WriteMsgTail
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] READ Command Process Completed"
		
		'terminate
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.Quit
	End Sub
	
	Sub TerminateInDeleteAll()
		'********************************************************************************
		' Puropose : Purge the messages, Terminate the script, 
		'            write help output to user
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:TerminateInDeleteAllMessages"
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] DELETE ALL Command Process Started"
		
		'Check and load the user message file if required
		If RaidenReqStoreFile.Loaded = False Then
			RaidenReqStoreFile.DestUser = cmdUser
			RaidenReqStoreFile.load		
		End If
		
		'Clear the data
		RaidenReqStoreFile.DeleteAllMessages
		
		'Write the Command Output
		PostMessage RaidenOutFile, "Deleted all Messages for user " & cmdUser
		
		'Update the notification file
		NotifyUser(cmdUSER)
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] DELETE ALL Command Process Completed"
		
		'terminate
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.Quit
	End Sub
	
	Sub TerminateInFill()
		'********************************************************************************
		' Puropose : Fill a request, write result output to user, Terminate the script
		' Input    : sItem : Reaquest sItem
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:TerminateInFill"
				
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] FILL Command Process Started"
		
		'Check and load the user message file if required
		If RaidenReqStoreFile.Loaded = False Then
			RaidenReqStoreFile.Server = cmdSERVER
			RaidenReqStoreFile.load		
		End If
		
		'check if we have all the inputs
		If (oArgs.Count < 7) Then
			TerminateInMsg currentSub, ERRORL ,"Request fill is missing parameter(s)"
		End If 
		
		'load the full string
		sItem = oArgs(6)
		For iCnt = 7 To oArgs.Count -1
			sItem = sItem & " " & oArgs(iCnt)
		Next
		
		'remove REQUEST_HEAD_REQ if found (FFxp selected support)
		If Left(sItem, Len(REQUEST_HEAD_REQ)) = REQUEST_HEAD_REQ Then
			If Not(Helper.FolderExists(REQUEST_FOLDER & "\" & REQUEST_HEAD_REQ & sItem, False)) Then
				sItem = Replace(sItem,REQUEST_HEAD_REQ,vbNullString,1,1)
			End if 
		End if		
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Checking Request: " & sItem
	    
	    'Check and Add
		 if RequestExists(sItem) And Helper.FolderExists(REQUEST_FOLDER & "\" & REQUEST_HEAD_REQ & sItem, False) then			
			'Update the folder Name to ARC_TRAIL_COMPLETE
			If Helper.UpdateFolderName(REQUEST_FOLDER, REQUEST_HEAD_REQ & sItem, REQUEST_HEAD_FILLED & sItem) Then
				'Move to Filled Folder
				If REQUEST_MOVE_FILLED Then
					Helper.MoveFolder REQUEST_FOLDER & "\" & REQUEST_HEAD_FILLED & sItem, REQUEST_FILLED_FOLDER
					UserLog.LogEvent SUCCESS, "[" & currentSub & "] Folder was moved to:" & REQUEST_FILLED_FOLDER 
				End If
				
				If REQUEST_CHMODE Then
					ChangeOwner REQUEST_MODE_FILLED,"*","*",REQUEST_FILLED_FOLDER & "\" & REQUEST_HEAD_FILLED & sItem,True
					UserLog.LogEvent SUCCESS, "[" & currentSub & "] Folder Ownership was Updated to User:" & "script" & " Group:" & "script" & " Mode:" & REQUEST_MODE_FILLED
				End If
			Else
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Unable to update the folder name to " & REQUEST_FILLED_FOLDER & "\" & REQUEST_HEAD_FILLED & sItem
			End If
			
			'Notify the user (Requires TuS-Message.v2.11 or higher)
			If ADDON_ENABLE_NOTIFICATION = True Then
				If Helper.FileExists(RAIDENFTPD_PATH & ADDON_MESSAGE_PATH,False) Then
					'retreive the Req Item
					Item = RaidenReqStoreFile.GetItemValue(sItem,6)
					'check & Send Messsage
					If Item(3) <> cmdUSER Then
						Notify Item(3), cmdSERVER, "[" & cmdUSER & "] Filled Request: " & sItem
						UserLog.LogEvent SUCCESS, "[" & currentSub & "] Notification Sent to user: " & Split(item(2),"|")(0)
					Else
						UserLog.LogEvent SUCCESS, "[" & currentSub & "] Notification Aborted: User filled his own Request"
					End If 
				Else
					UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to send Notification for user: " & Item(2)
				End If
			End If
			
			'Clear the data
			RaidenReqStoreFile.DeleteItem sItem,6
			
			'Write the Command Output
			PostMessage RaidenOutFile, "Filled: " &  sItem 

			'post the request message file
			If REQUEST_MSGFILE_ENABLE Then
				SaveToMessageFile "request"
			End If 
			
			'post the Directory message file
			If REQUEST_DIRMSGFILE_ENABLE Then
				SaveToDirFile "request", REQUEST_FOLDER & "\" & REQUEST_DIRMSGFILE_NAME
			End If 			

		Else
			'Write the Command Output
			PostMessage RaidenOutFile, "Unable to find Request: " & sItem
		End If 

        UserLog.LogEvent SUCCESS, "[" & currentSub & "] FILL Command Process Completed"
		'terminate
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.Quit
	End Sub
	
	Sub TerminateInDelete()
		'********************************************************************************
		' Puropose : Delete a request, write result output to user, Terminate the script
		' Input    : sItem : Request sItem
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:TerminateInDelete"
		Dim Item
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] DELETE Command Process Started"
		
		'Check and load the user message file if required
		If RaidenReqStoreFile.Loaded = False Then
			RaidenReqStoreFile.Server = cmdSERVER
			RaidenReqStoreFile.load		
		End If
		
		'check if we have all the inputs
		If (oArgs.Count < 7) Then
			TerminateInMsg currentSub, ERRORL ,"Request delete is missing parameter(s)"
		End If 
		
		'load the full string
		sItem = oArgs(6)
		For iCnt = 7 To oArgs.Count -1
			sItem = sItem & " " & oArgs(iCnt)
		Next
		
		'remove REQUEST_HEAD_REQ if found (FFxp selected support)
		If Left(sItem, Len(REQUEST_HEAD_REQ)) = REQUEST_HEAD_REQ Then
			If Not(Helper.FolderExists(REQUEST_FOLDER & "\" & REQUEST_HEAD_REQ & sItem, False)) Then
				sItem = Replace(sItem,REQUEST_HEAD_REQ,vbNullString,1,1)
			End if 
		End if		
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Checking Request: " & sItem
	
	    'Check and Add
		If RequestExists(sItem) And Helper.FolderExists(REQUEST_FOLDER & "\" & REQUEST_HEAD_REQ & sItem, False) Then	
			'Delete the folder
			If Helper.DeleteFolder(REQUEST_FOLDER & "\" & REQUEST_HEAD_REQ & sItem) Then
				UserLog.LogEvent SUCCESS, "[" & currentSub & "] Folder was deleted:" & REQUEST_HEAD_REQ & sItem 
			Else
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Unable to update the folder name to " & REQUEST_HEAD_FILLED & sItem
			End If
			
			'Notify the user (Requires TuS-Message.v2.11 or higher)
			If ADDON_ENABLE_NOTIFICATION = True Then
				If Helper.FileExists(RAIDENFTPD_PATH & ADDON_MESSAGE_PATH,False) Then
					'retreive the Req Item
					Item = RaidenReqStoreFile.GetItemValue(sItem,6)
										
					'check & Send Messsage
					If Item(3) <> cmdUSER Then
						Notify Item(3), cmdSERVER, "[" & cmdUSER & "] Deleted Request: " & sItem
						UserLog.LogEvent SUCCESS, "[" & currentSub & "] Notification Sent to user: " & Split(item(2),"|")(0)
					Else
						UserLog.LogEvent SUCCESS, "[" & currentSub & "] Notification Aborted: User deleted his own Request"
					End If 
				Else
					UserLog.LogEvent ERRORL, "[" & currentSub & "] Unable to find Addon message: " & RAIDENFTPD_PATH & ADDON_MESSAGE_PATH
				End If
			End If
			
			'Clear the data
			RaidenReqStoreFile.DeleteItem sItem,6

			'Write the Command Output
			PostMessage RaidenOutFile, "Deleted: " & sItem 

			'post the request message file
			If REQUEST_MSGFILE_ENABLE Then
				SaveToMessageFile "request"
			End If 
			
			'post the Directory message file
			If REQUEST_DIRMSGFILE_ENABLE Then
				SaveToDirFile "request", REQUEST_FOLDER & "\" & REQUEST_DIRMSGFILE_NAME
			End If 
		Else
			'Write the Command Output if it is user command only
			PostMessage RaidenOutFile, "Unable to find Request: " & sItem
		End If 

        UserLog.LogEvent SUCCESS, "[" & currentSub & "] DELETE Command Process Completed"
		'terminate
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.Quit
	End Sub
	
	Public Function BuildFolderPath(sItem)
		'********************************************************************************
		' Purpose : Build the Folder Name that will be created
		' Input   : string : sItem      : The item requested
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:BuildFolderName"
		Dim sRootFolder, sItemName, sNewFolderName
		
		'Default the sItemName
		sItemName = sItem
		
		sNewFolderName = REQUEST_HEAD_REQ & sItemName
		
		sRootFolder = REQUEST_FOLDER
		
		BuildFolderPath = sRootFolder & "\" & sNewFolderName
	End Function
	
	Public Function RequestExists(sItem)
		'********************************************************************************
		' Purpose : Check if Request allready exists
		' Input   : string : sItem      : The item requested
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:RequestExists"
		Dim Item
		
		'default
		RequestExists = False
		
		'retreive the Req Item
		Item = RaidenReqStoreFile.GetItemValue(sItem,6)
		
		'Check if it is in current request list
		If IsArray(Item) Then
			'PostMessage RaidenOutFile, "Request allready exists"
			RequestExists = true
		End if
	End Function
	
	Public Function Notify(sUser, sServer, sMessage)
		'********************************************************************************
		' Purpose : Notify the user
		' Input   : sUser	   : the user
		'           sMessage   : the Message
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:Notify"
		Dim sCmdRun, oFolder, Folder
	
		sCmdRun = "c:\windows\system32\cscript.exe " & Chr(34) & RAIDENFTPD_PATH & ADDON_MESSAGE_PATH & Chr(34)
		sCmdRun = sCmdRun & " " & Chr(34) & "0000000" & Chr(34) & " " & 1 & " " & Chr(34) & sServer & Chr(34) & " " & Chr(34) & SITECMD & Chr(34) & " message send " & sUser & " " & sMessage
		Helper.ShellRun sCmdRun,0,False,""
	End Function

	Public Sub SaveToDirFile(sDestUser,sDestFile)
		'********************************************************************************
		' Purpose : Save the Requests to the Directory Message File
		' Input   : sDestUser
		' Input   : sDestfile
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:SaveToDirFile"
		Dim iReqCnt, iCnt, iItemCnt, aItem, aTemplate, sOutMsg
		'On Error Resume Next
		
		'Check and load the user message file if required
		If RaidenReqStoreFile.Loaded = False Then
			RaidenReqStoreFile.User = sDestUser
			RaidenReqStoreFile.load		
		End If
		
		iReqCnt = RaidenReqStoreFile.Count
		
		'load and init the file
		RaidenOutFile.CmdType 	= "dirfile"
		RaidenOutFile.DestFile	= sDestFile
		RaidenOutFile.Initialize
		
		If (iReqCnt > 0) Then
			'output the nfo		
			If REQUEST_DIRMSGFILE_NFO <> vbNullString Then
				aTemplate = Helper.ReadFile(SCRIPTPATH & "\Nfo\" & REQUEST_DIRMSGFILE_NFO)
			
				If UBound(aTemplate) > 0 Then
					'process the lines
					For iCnt = 0 To UBound(aTemplate)
						If iCnt = 0 Then
							sOutMsg   = aTemplate(iCnt)
						Else
							sOutMsg   = sOutMsg & vbcrlf & aTemplate(iCnt)
						End if
					Next
					'Finally write the output Nfo
					RaidenOutFile.WriteNFO sOutMsg, False
				Else
					UserLog.LogEvent ERRORL, "[" & currentSub & "] Missing NFO Template file: " & SCRIPTPATH & "\Nfo\" & REQUEST_DIRMSGFILE_NFO
				End If
			End If 
			
			'write the file
			RaidenOutFile.WriteMsgHeaderNoResult
			iItemCnt = 1
			RaidenOutFile.SceneView = False
			RaidenOutFile.Width     = 300
			For Each aItem In RaidenReqStoreFile.ReadItems(cmdSERVER)
				RaidenOutFile.WriteMsgWithAppend "[#" & Helper.BuildString (iItemCnt,Len(REQUEST_MAX_LIMIT)) & "] " & aItem(6), "~ by " & aItem(3) & " (" & aItem(5) & ") at " & aItem(1),1,10 
				iItemCnt = iItemCnt + 1
			Next
			RaidenOutFile.SceneView = SCENEVIEW
			RaidenOutFile.Width     = WIDTH
			RaidenOutFile.WriteMsgTail
		Else
			RaidenOutFile.Close	
		End If 
				
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to write Directory Message file : site-Request-" & sDestFile & ". The error was : " & Err.description & " (" & Err.number & ")"
		End If
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] Directory Message file was saved"	
	End Sub
	
	Public Sub SaveToMessageFile(sDestUser)
		'********************************************************************************
		' Purpose : Save the Requests to the Request Message File
		' Input   : sDestUser
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:SaveToMessageFile"
		Dim iReqCnt, iCnt, iItemCnt, aItem, aTemplate, sOutMsg
		'On Error Resume Next
		
		'Check and load the user message file if required
		If RaidenReqStoreFile.Loaded = False Then
			RaidenReqStoreFile.User = sDestUser
			RaidenReqStoreFile.load		
		End If
		
		iReqCnt = RaidenReqStoreFile.Count
		
		RaidenOutFile.CmdType 	= "notify"
		RaidenOutFile.DestUser	= sDestUser
		RaidenOutFile.Initialize
		If (iReqCnt > 0) Then
			'output the nfo		
			If REQUEST_MSGFILE_NFO <> vbNullString Then
				aTemplate = Helper.ReadFile(SCRIPTPATH & "\Nfo\" & REQUEST_MSGFILE_NFO)
			
				If UBound(aTemplate) > 0 Then
					'process the lines
					For iCnt = 0 To UBound(aTemplate)
						If iCnt = 0 Then
							sOutMsg   = aTemplate(iCnt)
						Else
							sOutMsg   = sOutMsg & vbcrlf & aTemplate(iCnt)
						End if
					Next
					'Finally write the output Nfo
					RaidenOutFile.WriteNFO sOutMsg, False
				Else
					UserLog.LogEvent ERRORL, "[" & currentSub & "] Missing NFO Template file: " & SCRIPTPATH & "\Nfo\" & REQUEST_MSGFILE_NFO
				End If
			End If 
	
			'write the file
			RaidenOutFile.WriteMsgHeaderNoResult
			iItemCnt = 1
			RaidenOutFile.SceneView = False
			RaidenOutFile.Width     = 300
			For Each aItem In RaidenReqStoreFile.ReadItems(cmdSERVER)
				RaidenOutFile.WriteMsgWithAppend "[#" & Helper.BuildString (iItemCnt,Len(REQUEST_MAX_LIMIT)) & "] " & aItem(6), "~ by " & aItem(3) & " (" & aItem(5) & ") at " & aItem(1),1,10 
				iItemCnt = iItemCnt + 1
			Next
			RaidenOutFile.SceneView = SCENEVIEW
			RaidenOutFile.Width     = WIDTH
			RaidenOutFile.WriteMsgTail
		Else
			RaidenOutFile.Close	
		End If 
				
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to write User FTPD message file : site-Request-" & cmdSERVER & ".msg. The error was : " & Err.description & " (" & Err.number & ")"
		End If
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] Message file was saved"	
	End Sub

	Sub TerminateInSysErr()
		'********************************************************************************
		' Puropose : Terminate the script
		'            Inform the user about the error.
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:TerminateInSysErr" 
		
		UserLog.LogEvent ERRORL, "[" & currentSub & "] " & ABORT
		
		PostMessage RaidenOutFile, "An internal system error has occured. The error has been logged, please report this error to system administrator."
		UserLog.LogEvent ERRORL, "[" & currentSub & "] Script Aborted"
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.quit
	End Sub
	
	Sub Terminate()
		'********************************************************************************
		' Puropose : Terminate the script
		'            Inform the user about the error.
		' Input    : None
		'********************************************************************************
		Dim currentSub : currentSub = "Class CmdProcessorClass:Terminate" 
		
		UserLog.LogEvent ERRORL, "[" & currentSub & "] " & ABORT
		
		UserLog.LogEvent ERRORL, "[" & currentSub & "] An internal system error has occured. The error has been logged, please report this error to system administrator."
		UserLog.LogEvent ERRORL, "[" & currentSub & "] Script Aborted"
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.quit
	End Sub
	
	Sub TerminateInMsg(currentSub, ErrLevel ,sMessage)
		'********************************************************************************
		' Puropose : Terminate the script, write output message to user
		' Input    : string : sMessage : the message to post
		'********************************************************************************
		PostMessage RaidenOutFile, sMessage
		UserLog.LogEvent ErrLevel, "[" & currentSub & "] " & sMessage
		UserLog.LogEvent SUCCESS, "'#--------------------------------------------------------------------------------#"
		WScript.quit
	End Sub
	
	Sub PostMessage(oOutFile,sMessage)
		Dim currentSub : currentSub = "Class CmdProcessorClass:PostMessage"
		
		oOutFile.WriteMsgHeader
		oOutFile.WriteMsg sMessage,1,1
		oOutFile.WriteMsgTail
		
		UserLog.LogEvent SUCCESS, "[" & currentSub & "] " & "Posted Message: " & sMessage
	End Sub
End class	

'######################################################################################
' Class Wrapper for Helper. Functions
'######################################################################################
Class HelperClass
	Public oFso
	Public oShell,oExec,oFile,oStdOut,Element
	Private iSize,iInt,iCnt,iWordBreak,iCurrentLenth, intSeconds, intMilliseconds
	Public sScriptDir, sFilePath, sStreamData, sFolder, sUnc, sResult, sTempFile
	Private aResult
	Private bFound
	
	'#---------------------------------------------------------------------------#
	Private Sub Class_Initialize
		Set oFso		= CreateObject("Scripting.FileSystemObject")
		Set oShell		= CreateObject("Wscript.Shell")
	End Sub
	
	Private Sub Class_Terminate
		Set oFso		= Nothing
		Set oShell		= Nothing
	End Sub
	'#---------------------------------------------------------------------------#
	
	Function EchoErr(myError, sProcedure)
		'**********************************************************************************
		' Purpose : Verify and Post Err message
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helpers:EchoErr"
		
		If Err.Number <> 0 Then
			WScript.echo "[" & sProcedure & "] ERROR: Number:" & Err.Number & " : " & Err.Description
			UserLog.LogEvent ERRORL, "[" & sProcedure & "] ERROR: Number:" &Err.Number & " : " & Err.Description
		End If
	End Function
	
	Sub import (sFileName)
		sScriptDir = oFso.GetParentFolderName(WScript.ScriptFullName)   
		sFilePath = oFso.BuildPath(sScriptDir,sFileName)   
		Const ForReading = 1   
		
		Set oFile = oFso.OpenTextFile(sFilePath,ForReading)   
		sStreamData = oFile.ReadAll()   
		ExecuteGlobal sStreamData   
	End Sub
	
	Function UpdateFolderName(sPath,sName,sNewName)
		'**********************************************************************************
		' Purpose : Update a folder Name
		' Input   : string	: sPath	: Path to folder
		'           string	: sName	: Folder name
		'           string	: sNewName	: Folder New name
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:UpdateFolderName"
		Dim oFolder
		
		On Error Resume Next
		
		If oFso.FolderExists(sPath& "\" & sName) Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] Updating Folder Name: " & sPath& "\" & sName
			ofso.GetFolder(sPath& "\" & sName)
			If Err.number <> 0 Then
				UserLog.LogEvent ERRORL, "[" & currentSub & "] Error Updating: " & sPath& "\" & sName & ". The error was: " & Err.description
				UpdateFolderName = False
				Exit Function
			Else 
				ofso.MoveFolder sPath& "\" & sName, sPath& "\" & sNewName 
				If Err.number <> 0 Then
					UserLog.LogEvent ERRORL, "[" & currentSub & "] Error Updating: " & sPath& "\" & sName & ". The error was: " & Err.description
				Else
					UserLog.LogEvent SUCCESS, "[" & currentSub & "] Folder Name was updated to: " & sPath& "\" & sNewName & "."
					UpdateFolderName = True
				End if
				 
			End If
		Else 
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Folder does not exist: " & sPath& "\" & sName & "."
			UpdateFolderName = False 
		End If
	End Function


	Public Function Validate(sStringToTest,aArray)
		'#--------------------------------------------------------------------------------#
		' Purpose : Check if the element is part of an array
		'#--------------------------------------------------------------------------------#	
		bFound = False
		
		If (IsArray(aArray)) Then
			For Each Element In aArray				
				If LCase(sStringToTest) = LCase(Element) Then
					bFound = True
					Exit For
				End If
			Next 
		End If
		Validate = bFound
	End Function 
	
	Public Function GetSize(varArray)
		'#--------------------------------------------------------------------------------#
		' Purpose : Check the array size
		'#--------------------------------------------------------------------------------#	
		iSize = 0
		
		On Error Resume Next
		iSize = UBound(varArray)
		If Err.Number Then
			If Err.Number = 9 Then
				iSize = 0
			End If
		Else
			iSize = UBound(varArray) + 1
		End If
		GetSize = iSize
	End Function 
	
	Public Function  IsNothing (Obj)
		'#--------------------------------------------------------------------------------#
		' Purpose : Check if object is Nothing
		'#--------------------------------------------------------------------------------#	
		If TypeName(Obj) = "Nothing" Then
			IsNothing = True
		Else
			IsNothing = False
		End If
	End Function
	
	Function FileExists(sFilePath, bRequired)
		'**********************************************************************************
		' Purpose : Verify presense of a file, abort the script if the file is not present
		'		    and it's required.
		' Input   : string	: sFilePath 		: Path to file
		'           bool	: bRequired	: True|False
		' Return  : bool	: True|False
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:FileExists"
		
		If (oFso.FileExists(sFilePath)) Then
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] The file: " & sFilePath & " is present."
			FileExists = True
		Else
			UserLog.LogEvent ERRORL, "[" & currentSub & "] The file: " & sFilePath & " does not exist."
			FileExists = False
		End If
		
		If bRequired And FileExists = False Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] The file: " & sFilePath & " is required for futher processing of this script."
			CmdProcessor.TerminateInSysErr
		End If
	End Function
	
	Function FolderExists(sFolderPath, bRequired)
		'**********************************************************************************
		' Purpose : Verify presense of a folder, abort the script if the folder is not present
		'		    and it's required.
		' Input   : string	: sFFolderPath 		: Path to folder
		'           bool	: bRequired	: True|False
		' Return  : bool	: True|False
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:FolderExistsExists"
		
		If (oFso.FolderExists(sFolderPath)) Then
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] The Folder: " & sFolderPath & " is present."
			FolderExists = True
		Else
			UserLog.LogEvent ERRORL, "[" & currentSub & "] The Folder: " & sFolderPath & " does not exist."
			FolderExists = False
		End If
		
		If bRequired And FolderExists = False Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] The folder: " & sFolderPath & " is required for futher processing of this script."
			Helper.Terminate
		End If
	End Function
	
	Function FolderNotExists(sFolderPath, bRequired)
		'**********************************************************************************
		' Purpose : Verify presense of a folder, abort the script if the folder is not present
		'		    and it's required.
		' Input   : string	: sFFolderPath 		: Path to folder
		'           bool	: bRequired	: True|False
		' Return  : bool	: True|False
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:FolderNotExists"
		
		If (oFso.FolderExists(sFolderPath)) Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] The Folder: " & sFolderPath & " is present."
			FolderNotExists = False
		Else
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] The Folder: " & sFolderPath & " does not exist."
		    FolderNotExists = True
		End If
		
		If bRequired And FolderNotExists = False Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] The folder: " & sFolderPath & " is required for futher processing of this script."
			Helper.Terminate
		End If
	End Function
	
	Function CreateFolder(sPath)
		'**********************************************************************************
		' Purpose : Create a folder, or a subset of folders based upon one path. 
		'           Support both path and unc path. Ex : \\fqdn\share\my\path or 
		'           D:\share\my\path. If only \\fqdn\share or D:\Share exists, 
		'           function loop folder creation until path provided is created.
		' Input   : string	: sPath	: Path to folder
		' Return  : bool	: True if folder exists or successfully created
		'**********************************************************************************
		sFolder = vbnullString
		Dim currentSub : currentSub = "Class Helpers:CreateFolder"
		
		On Error Resume Next
		
		'Add missing \ if required
		If Right(sPath, 1) <> "\" Then
			sPath = sPath & "\"
		End If
		
		'Check if path is UNC replace base path \\server.fqdn\something with "\"
		If Left(sPath, 2) = "\\" Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] UNC Path: " & sPath
			sUNC = sPath
			Set oRegEx = New RegExp
			oRegEx.Pattern = "\\\\[A-Za-z0-9.]+\\\w+\$?\\"
			sResult = oRegEx.Replace (sPath, "")
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] UNC stripped, result: " & sResult
			sUnc = Left(sPath, Len(sPath) - Len(sResult))
			sFolder = sUnc
		End If
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Start creating directory structure: " & sPath
		
		'Check and create the folder tree
		Do Until sFolder = sPath
			sFolder = Left(sPath, InStr(Len(sFolder) + 1, sPath, "\"))
			'UserLog.LogEvent INFORMATION, "[" & currentSub & "] Checking if folder exists: " & sFolder
			If Not oFso.FolderExists(sFolder) Then
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Creating folder: " & sFolder
				ofso.CreateFolder(sFolder)
				If Err.number <> 0 Then
					UserLog.LogEvent ERRORL, "[" & currentSub & "] Error creating: " & sFolder & ". The error was: " & Err.description
					Exit Function
				End If
			End If
		Loop
		
		If Right(sPath, 1) = "\" Then
			sPath = Left(sPath, Len(sPath) -1)
		End If
		CreateFolder = True
	End Function
	
	Function MoveFolder(byval sPath, byval sDestPath)
		'**********************************************************************************
		' Purpose : Move a folder
		' Input   : string	: sPath	: Path to folder
		' Input   : string	: sDestPath	: Path to folder
		' Return  : bool	: True if folder exists or successfully created
		'**********************************************************************************
		Dim sFolder : sFolder = vbnullString
		Dim currentSub : currentSub = "Class Helpers:MoveFolder"
		
		On Error Resume Next
		
		'Add missing \ if required
		If Right(sPath, 1) <> "\" Then
			sPath = sPath & "\"
		End If
		
		If Right(sDestPath, 1) <> "\" Then
			sDestPath = sDestPath & "\"
		End If
		
		'Check if path is UNC replace base path \\server.fqdn\something with "\"
		If Left(sPath, 2) = "\\" Then
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] UNC Path: " & sPath
			sUNC = sPath
			Set oRegEx = New RegExp
			oRegEx.Pattern = "\\\\[A-Za-z0-9.]+\\\w+\$?\\"
			sResult = oRegEx.Replace (sPath, "")
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] UNC stripped, result: " & sResult
			sUnc = Left(sPath, Len(sPath) - Len(sResult))
			sFolder = sUnc
		End If
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Start creating directory structure: " & sDestPath
		
		'Check and create the folder tree
		Do Until sFolder = sDestPath
			sFolder = Left(sDestPath, InStr(Len(sFolder) + 1, sDestPath, "\"))
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] Checking if folder exists: " & sFolder
			If Not oFso.FolderExists(sFolder) Then
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] Creating folder: " & sFolder
				ofso.CreateFolder(sFolder)
				If Err.number <> 0 Then
					UserLog.LogEvent ERRORL, "[" & currentSub & "] Error creating: " & sFolder & ". The error was: " & Err.description
					Exit Function
				End If
			End If
		Loop
		
		'All good now do the move
		'Remove \ if required
		If Right(sPath, 1) = "\" Then
			sPath = Left(sPath, Len(sPath) -1)
		End If
		
		If Right(sDestPath, 1) = "\" Then
			sDestPath = Left(sDestPath, Len(sDestPath) -1)
		End If

		oFso.MoveFolder sPath, sDestPath & "\" & Right(sPath, Len(sPath) - InStrRev(sPath, "\"))
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Error Moving: " & Chr(34) & sPath & Chr(34) & ". The error was: " & Err.description
			Exit Function
		End If
		
		If Right(sPath, 1) = "\" Then
			sPath = Left(sPath, Len(sPath) -1)
		End If
		MoveFolder = True
	End Function
	
	Function DeleteFile(sPath)
		'**********************************************************************************
		' Purpose : Delete file
		' Input   : String : sPath : path to file
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helpers:DeleteFile"
		
		On Error Resume Next
		Err.clear
		
		oFso.DeleteFile sPath, True
		
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to delete File: " & sPath & ". The error was: " & Err.description & " (" & Err.number & ")"
			DeleteFile = False 
		Else
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] File: " & sPath & " was successfully deleted."
			DeleteFile = True 
		End If
	End Function
	
	Function DeleteFolder(sPath)
		'**********************************************************************************
		' Purpose : Delete file
		' Input   : String : sPath : path to file
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helpers:DeleteFolder"
		
		On Error Resume Next
		Err.clear
		
		oFso.DeleteFolder sPath, True
		
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to delete Folder: " & sPath & ". The error was: " & Err.description & " (" & Err.number & ")"
			DeleteFolder = False 
		Else
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] Folder: " & sPath & " was successfully deleted."
			DeleteFolder = True 
		End If
	End Function
	
	Function GetDayTimeDate()
		'**********************************************************************************
		' Purpose : Get Day,Date,Time
		' Input   : None
		' Return  : Current day of week + Date + Time
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helpers:GetDayTimeDate"
		
		GetDayTimeDate = WeekdayName(Weekday(Now, vbUseSystemDayOfWeek),,vbUseSystemDayOfWeek) & " " & Date & " "
		
		intSeconds = (Hour(Now) * 3600) + (Minute(Now) * 60) + Second(Now) 
        intMilliseconds = Timer() - intSeconds 
        intMilliseconds = Fix(intMilliseconds * 10000) 
		
		If CInt(Hour(Now)) < 10 Then
			GetDayTimeDate = GetDayTimeDate & "0" & Hour(Now) & "."
		Else
			GetDayTimeDate = GetDayTimeDate & Hour(Now) & "."
		End If
		
		If CInt(Minute(Now)) < 10 Then
			GetDayTimeDate = GetDayTimeDate & "0" & Minute(Now) & "."
		Else
			GetDayTimeDate = GetDayTimeDate & Minute(Now) & "."
		End If
		
		If CInt(Second(Now)) < 10 Then
			GetDayTimeDate = GetDayTimeDate & "0" & Second(Now)
		Else
			GetDayTimeDate = GetDayTimeDate & Second(Now)
		End If
		
		If InStr(GetDayTimeDate, "/") Then
			GetDayTimeDate = Replace(GetDayTimeDate, "/", ".")
		End If
		If InStr(GetDayTimeDate, "\") Then
			GetDayTimeDate = Replace(GetDayTimeDate, "\", ".")
		End If
		
		GetDayTimeDate = GetDayTimeDate & "_" & intMilliseconds
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Creating Date " & GetDayTimeDate
	End Function
	
	Function Random(iValue)
		'**********************************************************************************
		' Purpose : Create a random integer between 0 and i
		' Input   : integer		: iValue	: The max value
		' Return  : integer		: Random number between 0 and Input (i)
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helpers:Random"
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Creating a random integer between: 0-" & iValue
		
		'Generate seed
		Randomize
		iInt = Int(iValue * Rnd)
		
		UserLog.LogEvent INFORMATION, "[" & currentSub & "] Random integer is: " & iInt
		Random = iInt
	End Function
	
	Function ReadFile(sPath)
		'**********************************************************************************
		' Purpose : Read an entire text file
		' Input   : String : sPath : path to file
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:ReadFile"
		
		On Error Resume Next
		Err.clear
		
		If Helper.FileExists(sPath,False) Then
			aResult = Split(oFso.OpenTextFile(sPath,1).ReadAll,vbCRLF)
			
			'Just logging
			UserLog.LogEvent INFORMATION, "[" & currentSub & "] Read Output: "
			For iCnt = 0 To UBound(aResult)
				UserLog.LogEvent INFORMATION, "[" & currentSub & "] -" & aResult(iCnt)
			Next
			
			If Not(IsNull(aResult)) Then
				ReadFile = aResult
			Else
				ReadFile = Array()
			End If
		Else
			ReadFile = Array()
		End If 
		
		If Err.number <> 0 Then
			UserLog.LogEvent ERRORL, "[" & currentSub & "] Failed to Read File: " & sPath & ". The error was: " & Err.description & " (" & Err.number & ")"
		End If
	End Function
	Sub Terminate()
		'**********************************************************************************
		' Puropose : Terminate the script, moving log to error directory.
		'            Inform the user about the error.
		' Input    : None
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper.s:Terminate"
		
		UserLog.LogEvent ERRORL, "[" & currentSub & "] ABORT."
		WScript.quit
	End Sub

	Function BreakString (byval str, byval str2, length, fillSpaces, iWordBreakStart) 
		'********************************************************************************
		' Purpose	: Break up a string into multiline string having a given length
		' Input   	: string	: str		: the input string
		'			  string	: str2		: the input string to append at the end
		'			  integer	: length	: the desired final length
		' 			  bool	: fillSpaces: option to fill spaces
		'********************************************************************************
		Dim currentSub : currentSub = "Class Helpers:BreakString"
		
		'fill with spaces
		ReDim aResult(0)
		
		iCnt = 0
		'process the main string
		While (Len(str) > length) 
			iWordBreak = InStrRev(str, " ", length)
			If iWordBreak <= iWordBreakStart Then
				iWordBreak = 0
			End if
			'force a break if no word break detected
			If (iWordBreak = 0) Then
				iWordBreak = length
			End If
			ReDim Preserve aResult(iCnt)
			aResult(iCnt) = Left(str, iWordBreak)
			str = Right(str,Len(str)-iWordBreak)
			iCnt = iCnt + 1
		Wend
		'check if the remaining string can accept the append of str2
		If (Len(str)+Len(str2)+1 >length) Then
			ReDim Preserve aResult(iCnt)
			aResult(iCnt) = str
			If (Len(Trim(str2))> 0) Then
				ReDim Preserve aResult(iCnt+1)
				If fillSpaces Then
					aResult(iCnt+1) = Space(length - Len(str2)) & str2
				Else
					aResult(iCnt+1) = str2
				End If
			End If
		Else
			ReDim Preserve aResult(iCnt)
			If fillSpaces Then
				aResult(iCnt) = str & Space(length - Len(str)- Len(str2)) & str2
			Else
				If (Len(str2) > 0) Then
					aResult(iCnt) = str & Space(1) & str2
				Else	
					aResult(iCnt) = str
				End If
			End If
		End If
		BreakString = aResult
	End Function
	
	Function BuildString (str, length)
		'********************************************************************************
		' Purpose : fill up a string with space to a given length
		' Input   : string	: str		: the input string
		'			integer : length	: the desired final length
		'********************************************************************************
		Dim currentSub : currentSub = "Class Helpers:BuildString"
		
		'fill with spaces
		iCurrentLenth = Len(str)
		str = str & Space(length - iCurrentLenth)
		
		buildString = str
	End Function
	
	Public Function ShellRun(sCmd, iWinStyle, bWait, sWorkDir)
		'**********************************************************************************
		' Purpose : Execute a command, It will then execute the command in a shell, 
		'           and capture the output into a file. That file is then read in and its 
		'           contents are returned as an Array() in the value the function returns.
		' Inputs : String : sCmd : The command to execute
		'		   Integer: iWinStyle : the window style (check VBS help for values)
		'		   Bool   : bWait : Wait for execution complete and return the output
		' Output : Array  : ShellRun : the actual output if any
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:ShellRun"
				
		sTempFile = GetTempFilename()
		On Error Resume Next 
		
		Dim sCmdOnly, sCmdPath, sCmdDrive, sCmdWorkDir, cmdOutput
		Dim COMSPEC : COMSPEC = "%comspec% /c "
		
		UserLog.LogEvent Information, "[" & currentSub & "] Command is : ["  & sCmd  & "]" & " and Work dir is: " & sWorkDir
		
		'Switch the current dir to sWorkDir or Default to command exe dir
		If sWorkDir <> vbNullString Then
			sCmdWorkDir = sWorkDir
		Else
			'Build the %comspec% to set drive and work directory
			If InStr(sCmd,Chr(34)) = 1 Then 'command is quoted
				sCmdOnly = Left(sCmd, InStr(2,sCmd,Chr(34)))
				sCmdOnly = Replace(sCmdOnly,Chr(34),vbNullString)
			Else
				sCmdOnly = Left(sCmd, InStr(2,sCmd,Chr(32)))
				sCmdOnly = Replace(sCmdOnly,Chr(32),vbNullString)
			End If 	
			sCmdWorkDir = Left(sCmdOnly, InStrRev(sCmdOnly,"\")-1)
		End If
		
		'Build the COMSPEC
		If InStr(sCmdWorkDir,":") = 2 Then 
			'extract drive info
			sCmdDrive = Left(sCmdWorkDir, InStr(sCmdWorkDir,":"))
			COMSPEC = COMSPEC & sCmdDrive & " " & chr(38) & " "
			'extract Path info
			sCmdpath = sCmdWorkDir
			If InStr(sCmdPath,Chr(32)) > 0 Then
				sCmdPath = Chr(34) & sCmdPath & Chr(34)
			End if
			COMSPEC = COMSPEC & "cd " & sCmdPath & " " & chr(38) & " "
		End If 
				
		If bWait Then
			oShell.Run COMSPEC &  sCmd  & " > " & sTempFile, iWinStyle, true
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] Command Execute (Wait): [" & COMSPEC & sCmd  & " > " & sTempFile & "]"
			If Helper.FileExists(sTempFile,False) Then
				cmdOutput = Split(oFso.OpenTextFile(sTempFile,1).ReadAll,vbCRLF)
				If Err.Number = 62 Then
					UserLog.LogEvent WARNING, "[" & currentSub & "] No Output result from Command Execute"
					'Clear error
					Err.Clear
				Else
					'Just Debug
					UserLog.LogEvent SUCCESS, "[" & currentSub & "] Command Execute has Output Results."
					For iCnt = 0 To UBound(cmdOutput)
						UserLog.LogEvent INFORMATION, "[" & currentSub & "] -" & cmdOutput(iCnt)
					Next
				End If
	
				oFso.DeleteFile sTempFile, true
			Else
				UserLog.LogEvent WARNING, "[" & currentSub & "] No Output result generated from Command Execute"
			End If  
			ShellRun = cmdOutput
		Else 
			oShell.Run COMSPEC & sCmd, iWinStyle, false
			UserLog.LogEvent SUCCESS, "[" & currentSub & "] Command Execute (No Wait): " & sCmd
			ShellRun = Array()
		End If 
			
		If Err.Number <> 0 Then
			Helper.EchoErr Err, currentSub
			'Clear error
			Err.clear
		End If
	End Function

	Public Function GetTempFilename()
		'**********************************************************************************
		' Purpose : Generate e temporary file, 
		' Inputs : None
		' Output : StringArray  : ShellRun : the actual output if any
		'**********************************************************************************
		Dim currentSub : currentSub = "Class Helper:GetTempFilename"
		
		GetTempFilename = oShell.ExpandEnvironmentStrings("%temp%") & oFso.GetTempName
	End Function	
End Class

Public Sub Class_Event(sSource, sEventType,ByVal bResult,ByVal values)
	'********************************************************************************
	' Purpose : Fire an event received from the child objects
	'********************************************************************************
	Dim currentSub : currentSub = "Main:Class_Event"
	
	If IsArray(values) Then
		values = Join(values,"|")
	ElseIf (values = vbNullString) Then
		values = "Null"
	End If 
	
	If (TypeName(DEBUG_CLASS_EVENTS) <> "Nothing") Then
		If (DEBUG_CLASS_EVENTS = True) Then
			WScript.Echo "EVENT FIRED [" & currentSub & "] source: " & sSource & " ; EventType:" & sEventType & " ; Result:" & bResult & " ; values:" & values
		End If
	End If 
End Sub

Sub Import (sFileName)
	'**********************************************************************************
	' Purpose : Import external file
	'**********************************************************************************
	Dim oFso, oFile
	Dim sScriptDir, sFilePath, sStreamData
	
	Set oFso		= CreateObject("Scripting.FileSystemObject")
	sScriptDir = oFso.GetParentFolderName(WScript.ScriptFullName)   
	sFilePath = oFso.BuildPath(sScriptDir,sFileName)   
	Const ForReading = 1   
	
	Set oFile = oFso.OpenTextFile(sFilePath,ForReading)   
	sStreamData = oFile.ReadAll()   
	ExecuteGlobal sStreamData   
End Sub